draw_th0:
  xor eax,eax
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0
ret

draw_th1:
  mov eax,1
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,1
ret

draw_th2:
  mov  eax,2
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,2
ret

draw_th3:
  mov  eax,3
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,3
ret



draw_thread:	; in: eax - thread number; 0 - first thread
    push ebp
    mov  ebp,esp
    push eax
    sub  esp,128

    .thread_no equ dword[ebp-4]
    .y_min     equ word[ebp-6]
    .y_max     equ word[ebp-8]

    .third_p_index  equ dword[ebp-12]
    .second_p_index equ dword[ebp-16]
    .first_p_index  equ dword[ebp-20]

    .xx1  equ word[ebp-24]
    .xx1f equ dword[ebp-28]
    .xx2  equ word[ebp-32]
    .xx2f equ dword[ebp-36]
    .xx3  equ word[ebp-40]
    .xx3f equ dword[ebp-44]
    .yy1  equ word[ebp-48]
    .yy1f equ dword[ebp-52]
    .yy2  equ word[ebp-56]
    .yy2f equ dword[ebp-60]
    .yy3  equ word[ebp-64]
    .yy3f equ dword[ebp-68]
    .zz3  equ [ebp-70]
    .zz2  equ [ebp-72]
    .zz1  equ [ebp-74]
    .zz1f equ dword[ebp-84]
    .zz2f equ dword[ebp-88]
    .zz3f equ dword[ebp-92]
    .xy1 equ ebp-96
    .xy2 equ ebp-100
    .xy3 equ ebp-104
    .x_temp_var equ dword [ebp-108]
    .y_temp_var equ dword [ebp-112]
    .counter	equ dword [ebp-116]

    cmp    [draw_flag],9
    jl	   @f
    push   [yres_var]
    pop    .y_max
    mov    .y_min,0
    jmp    .skip_div
  @@:
    movzx  ebx,[yres_var]
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx

 .skip_div:



    mov   esi,[triangles_ptr]		 ; draw triangles
    movzx ecx,[triangles_count_var]
  .draw_triangle:
    push  ecx
    fninit
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .first_p_index,edx
    add   edx,[points_rotated_ptr]
    fld   dword[edx]
    fst   .xx1f
    fistp .xx1
    movzx eax, .xx1
    shl   eax,16
    fld   dword[edx+4]
    fst   .yy1f
    fistp .yy1
    mov   ax,.yy1
    fld   dword[edx+8]
    fist  word .zz1
    fstp  .zz1f
					; z coord - skip
    movzx edx,word[esi+2]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .second_p_index,edx
    add   edx,[points_rotated_ptr]
    fld   dword [edx]
    fst   .xx2f
    fistp .xx2
    movzx ebx, .xx2
    shl   ebx,16
    fld   dword[edx+4]
    fst   .yy2f
    fistp .yy2
    mov   bx, .yy2
    fld   dword[edx+8]
    fist  word .zz2
    fstp  .zz2f

    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .third_p_index, edx
    add   edx,[points_rotated_ptr]
    fld   dword[edx]
    fst   .xx3f
    fistp .xx3
    movzx ecx,.xx3
    shl   ecx,16
    fld   dword[edx+4]
    fst   .yy3f
    fistp .yy3
    mov   cx,.yy3
    fld   dword[edx+8]
    fist  word .zz3
    fstp  .zz3f

    mov     dword [.xy1],eax
    mov     dword [.xy2],ebx
    mov     dword [.xy3],ecx

    push  esi
    pushad



















    cmp   [draw_flag],1
    je	  .flat_draw

    cmp   [draw_flag],3
    je	  .env_mapping
;    je    .flat_draw_float
;    cmp   [draw_flag],8
;    je    .flat_draw_float
    cmp   [draw_flag],4
    je	  .bump_mapping
    cmp   [draw_flag],5
    je	  .tex_mapping
    cmp   [draw_flag],8
    je	  .bump_tex_mapping
    cmp   [draw_flag],7
    je	  .two_tex
    cmp   [draw_flag],6
    je	  .grd_tex
    cmp   [draw_flag],9
    je	  .grd_line
    cmp   [draw_flag],10
    je	  .flat_draw_float
    cmp   [draw_flag],14
    je	  .draw_dots
    cmp   [draw_flag],11
    je	  .tex_line
    cmp   [draw_flag],12
    je	  .tex_line
    cmp   [draw_flag],13
    je	  .flat_line
    cmp   [draw_flag],0
    je	  .point_light

     .grd_draw: 	       ;****Gouraud shading****
	fninit


	push   .y_max
	push   .y_min
	lea	esi, .third_p_index
	lea	ebx, .zz1
	mov	ecx,3
      .again_grd_draw:
	mov	eax,[esi]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.x_temp_var    ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.y_temp_var

	mov	eax,.y_temp_var
	shl	eax,TEX_SHIFT
	add	eax,.x_temp_var
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+ebx-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_draw

if 0
   ; -----------version with only one light supported------
    mov   [.counter],4	    ; ++++ gouraud shading  ++++++++
  .calc_col_LVD:    ; calculate color Light Vector Depend
    mov   edx,[.counter]
    push  [zz1+edx]
; calc color of triangle light vector dependent
    mov   esi,light_vect
    mov   edi,[points_normals_rotated_ptr]
    add   edi,[first_p_index+2*edx]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx


    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

;    shufps    xmm3,xmm3,11000110b

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxuw    xmm3,[minimum0]
;    pminuw    xmm3,[maximum255]

    movd      edx,xmm3
  ;  ror       edx,16
    push      edx
    psrldq    xmm3,4
    movd      edx,xmm3
    push      dx

    sub   [.counter],2
    cmp   [.counter],0
    jge   .calc_col_LVD


end if

    mov     eax,[.xy1]
    mov     ebx,[.xy2]
    mov     ecx,[.xy3]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z
    jmp   .end_draw

  .point_light:
    push     .y_max
    push     .y_min
    movups   xmm5,[point_light_coords]
    xor      eax,eax
    lea      esi,.first_p_index
  .next_vertex:
    movaps   xmm1,xmm5
    mov      ebx,[esi+2*eax]

    mov      edx,ebx
    add      ebx,[points_rotated_ptr]
    movups   xmm2,[ebx]
    andps    xmm2,[zero_hgst_dd]
    subps    xmm1,xmm2
    sub      esp,16
    movups   [esp],xmm1
    mov      edi,esp
    call     normalize_vector  ; uses xmm6,xmm7
    movups   xmm1,[edi]
    add      esp,16
    add      edx,[points_normals_rotated_ptr]
    movups   xmm3,[edx]
    andps    xmm3,[zero_hgst_dd]
    mulps    xmm3,xmm1
    haddps   xmm3,xmm3	   ; sse3 required
    haddps   xmm3,xmm3	   ; xmm3 - dot product
    xorps    xmm4,xmm4
    maxps    xmm3,xmm4
    shufps   xmm3,xmm3,11000000b
    movaps   xmm4,xmm3
    mov      ecx,5
  @@:
    mulps    xmm4,xmm4
    sub      ecx,1
    jnz      @b

;    imul     eax,[i38]     ; 38 - one light parameter size
    movq      xmm0,[p_light_max]    ;+eax
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    mulps     xmm4,xmm2     ; xmm4 reflection(emmisive?) component of light

    movq      xmm0,[p_light_o] ;+ eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm4,xmm2

    movq      xmm0,[p_light_min] ; + eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0

    mulps     xmm2,xmm3
    addps     xmm4,xmm2
    minps     xmm4,[mask_255f]

    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4

    movd      edx,xmm4
    lea       edi,.zz1
    push      word[edi+eax]
    push      edx
    psrldq    xmm4,4
    movd      edx,xmm4
    push      dx

    add       eax,2
    cmp       eax,6
    jnz       .next_vertex

    mov     eax,[.xy3]
    mov     ebx,[.xy2]
    mov     ecx,[.xy1]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z


    jmp   .end_draw





  .draw_dots:
	mov	edi,[screen_ptr]
	mov	eax,[.xy1]

;	 mov	 edx,[yres_var]
	cmp	ax,[yres_var]  ; SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	ror	eax,16

   ;	 mov	 edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	movzx	edx,[xres_var] ;SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1
;------------------
	mov	eax,[.xy2]
 ;	 mov	 edx,[yres_var]
	cmp	ax,[yres_var] ;dx ;SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16
;	 mov	 edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	movzx	edx,[xres_var];SIZE_X
	ror	eax,16

	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	mov	eax,[.xy3]
      ;  mov	 edx,[yres_var]
	cmp	ax,[yres_var] ;dx ;SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16

    ;	 mov	 edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
     ;	 mov	 edx,SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	jmp   .end_draw
  .grd_line:		    ;****Gouraud line****
	fninit
	push   .y_max
	push   .y_min

	lea	esi,.third_p_index
	mov	ecx,3
      .again_grd_line_param:
	mov	eax,[esi]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.x_temp_var    ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.y_temp_var

	mov	eax,.y_temp_var
	shl	eax,TEX_SHIFT
	add	eax,.x_temp_var
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	mov	[ecx*4+col1-4],eax

	sub	 esi,4
	dec	 ecx			; decode all 3 edges
	jnz	 .again_grd_line_param


	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]

	mov	eax,[col1]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	word .zz1

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	mov	eax,[col2]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	word .zz2

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	call	smooth_line	; draw only one edge

    jmp   .end_draw



  .tex_line:		    ;****textured line****



	cmp	[draw_flag],12
	je	@f

	fninit
	sub	esp,4
	mov	edx,.first_p_index
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff1
     @@:
	mov    eax,.first_p_index      ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]
     .pushzbuff1:
	push	word .zz1

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	cmp	[draw_flag],12
	je	@f
	sub	esp,4
	mov	edx,.second_p_index
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff2
     @@:
	mov    eax,.second_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]
     .pushzbuff2:

	push	word .zz2

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]
	mov	edx,envmap
	cmp	[draw_flag],12
	jne	@f
	mov	edx,texmap
     @@:
	call	tex_line     ; draw only one edge

    jmp   .end_draw

  .flat_line:		     ;****simple line****
			     ; without z coord. interpolation

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    or		eax,ecx
    test	eax,80008000h
    jne 	.end_draw

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    inc 	ax
    cmp 	ax,[yres_var] ;SIZE_Y
    jg		.end_draw
    inc 	cx
    cmp 	cx,[yres_var] ;SIZE_Y
    jg		.end_draw
    ror 	eax,16
    inc 	ax
    cmp 	ax,[xres_var] ;SIZE_X
    jg		.end_draw
    ror 	ecx,16
    inc 	cx
    cmp 	cx,[xres_var] ;SIZE_X
    jg		.end_draw

	movzx	 ebx,[xres_var]
	mov	 [screen_width_var],ebx ;,XRES

	mov	 eax,[.xy1]
    ;	 ror	  eax,16
	movzx	 ebx,ax
	shr	 eax,16
	mov	 ecx,[.xy2]
   ;	 ror	  ecx,16
	movzx	 edx,cx
	shr	 ecx,16

	push	 [screen_ptr]
	pop	 [lbuffer_ptr]

	call	 linea

	jmp	.end_draw


    .grd_tex:
	push   .y_max
	push   .y_min

	fninit

	mov    eax, .third_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .second_p_index	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .first_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	lea	esi, .third_p_index
	mov	ecx,3

      .again_grd_tex_draw:

	mov	eax,[esi]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.x_temp_var    ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.y_temp_var

	mov	eax,.y_temp_var
	shl	eax,TEX_SHIFT
	add	eax,.x_temp_var
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	lea	ebx,.zz1
	push	word[ecx*2+ebx-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_tex_draw


	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,[Zbuffer_ptr]
	mov	edx,texmap

	call	tex_plus_grd_triangle



	jmp    .end_draw



     .flat_draw:		     ;**************************				     ; FLAT DRAWING
	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,.first_p_index
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	mov	ebx,.second_p_index
	add	ebx,[points_normals_rotated_ptr]
	fadd	dword[ebx]
	mov	ecx,.third_p_index
	add	ecx,[points_normals_rotated_ptr]
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.x_temp_var ;[esp-4]	; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.y_temp_var;[esp-8]   ;  y
	mov	edx,.x_temp_var  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,.y_temp_var ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax

	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]
	push	.y_min
	push	.y_max
	push	word .zz3
	push	word .zz2
	push	word .zz1

	call	flat_triangle_z

    jmp   .end_draw






    .env_mapping:
	push	.y_max
	push	.y_min
	push	word .zz3
	push	word .zz2
	push	word .zz1
	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	.counter,3
	lea	ebx,.first_p_index
      @@:
	mov	edx,[esi+ebx]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	sub	.counter,1
	jnz	@b

      ;  mov	eax,[.xy1]
	mov    ebx,[.xy2]
      ;  mov	ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,envmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw


 .flat_draw_float:
    push  .zz3f
    push  .zz2f
    push  .zz1f

; calc color of triangle light vector dependent

	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax, .first_p_index
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	mov	ebx, .second_p_index
	add	ebx,[points_normals_rotated_ptr]
	fadd	dword[ebx]
	mov	ecx, .third_p_index
	add	ecx,[points_normals_rotated_ptr]
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.x_temp_var ;[esp-4]	; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	.y_temp_var;[esp-8]   ;  y
	mov	edx,.x_temp_var  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,.y_temp_var ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax



if 0
    mov   esi,light_vect
    mov   edi,[points_normals_rotated_ptr]
    add   edi,[first_p_index]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx

    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxub    xmm3,[minimum0]
;    pminub    xmm3,[maximum255]
    packuswb  xmm3,xmm3
    movd      edx,xmm3
end if




    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]

    call  flat_triangle_z_float
    jmp     .end_draw
;end if

  .tex_mapping:
	push	.y_max
	push	.y_min
	push	word .zz3
	push	word .zz2
	push	word .zz1
   ;  cmp    [hrt_flag],3	   ; check tetrahedron object cause
   ;  je     @f
	mov    eax,.third_p_index      ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,.second_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,.first_p_index      ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

    .no_tetra:
	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw


    .bump_mapping:
	push	.y_max
	push	.y_min
	push	[Zbuffer_ptr]
	push	word .zz3
	push	word .zz2
	push	word .zz1

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	.counter,3
	lea	ebx,.first_p_index
      @@:
	mov	edx,[esi+ebx]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	.counter
	jnz	@b

	mov    eax, .third_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .second_p_index	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .first_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_triangle_z
	jmp    .end_draw

    .two_tex:		    ; double texture mapping
	push	.y_max
	push	.y_min
	push	[Zbuffer_ptr]
	push	word .zz3
	push	word .zz2
	push	word .zz1

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	.counter,3
	lea	ebx,.first_p_index
      @@:
	mov	edx,[esi+ebx]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	.counter
	jnz	@b

   ;  cmp    [hrt_flag],3	   ; check tetrahedron object cause
   ;  je     @f

	mov    eax, .third_p_index	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .second_p_index	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .first_p_index	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]



	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,texmap

	call	two_tex_triangle_z
	jmp    .end_draw


    .bump_tex_mapping:
	push   .y_max
	push   .y_min
	mov    eax,.third_p_index      ; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,.second_p_index	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,.first_p_index      ; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	push	texmap

	push	[Zbuffer_ptr]
	push	word .zz3
	push	word .zz2
	push	word .zz1

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	.counter,3
      @@:
	lea	edx,.first_p_index
	mov	edx,[edx+esi]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	.counter
	jnz	@b

    ; cmp    [hrt_flag],3	   ; check tetrahedron object cause
    ; je     @f
	mov    eax, .third_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .second_p_index	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax, .first_p_index	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]




	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_tex_triangle_z



   .end_draw:

    popad
    pop   esi
    add   esi,6
    pop    ecx
    sub    ecx,1
    jnz    .draw_triangle


  mov esp,ebp
  pop ebp
ret