;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ave Cruce Salus Mea
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program: Win3ds15 - *.3ds / *.asc files viewer + demonstration of
;;	    several graphics effects + tiny based on Bezier curves,
;;	    3d objects editor.
;; author:  Maciej Guba aka macgub
;; web	 :  www.macgub.hekko.pl
;; email :  macgub3@wp.pl
;; This application don't uses any 3d graphic library
;; (OGL, GTK, ..etc). Written from scratch in pure assembler. Thanks
;; to all, who was helping me to do it.
;; Program needs SSE3, SSE4.1 or AVX extension.
;; Coding style is rather ugly. Other words it's my own mess. ;)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Keys / GUI Buttons description:
;;	    SPACE / 'dr. model' button -  switching beetwen displaying
;;	       models: flat, smooth shading, spherical environment,
;;	       texture, bump, smooth + texture, two texture and bump
;;	       + texture mapping pararell, edges only (smooth shaded,
;;	       textured lines), flat with float single precision Z
;;	       coordinate, point light with shadow light position
;;	       dependent;
;;	    TAB / 'ran. light' - generate three unlinear directional
;;	       lights (Phongs illumination);
;;	    F1 / 'mot. blur' - motion blur on/off;
;;	    F2 / 'cur object' - cyclic switching between objects (from
;;	       file and predefined: heart (Sanctissimi Cordis Christi)
;;	       and tetrahedron), also turning on edit rotary Bezier
;;	       object option - ( Setting object parameters:
;;	       green line with	blue begin and end - rotary arbitrary
;;	       vector, green lines with red bars - derives, to change
;;	       derives	and arbitrary vector move cursor on red, or blue
;;	       bar, press left button on it and move mouse. Currently
;;	       edited object will be  show on the fly. Rotate independent
;;	       current segment of Bezier solid, marked with green frame,
;;	       by pressing and moving left mouse button on main view
;;	       window. Rotating independent segment around its center
;;	       point.); Also Bezier pipes editing option - (editing
;;	       pipes like in previous rotary object, but rotatry vector,
;;	       in this editing option its lenght determines Bezier pipes
;;	       radius, also independent pipe segment rotating around its
;;	       center point are implemented); Also rotated solids and
;;	       pipes pararell drawing possibility, editing options like
;;	       in previous causes. As I wrote, switching beetwen editing
;;	       options by pressing F2 / cur object GUI button;
;;	    F3/F4(+/-) keys / 'zoom in/out' buttons - no comment;
;;	    F5 / 'tex. mapp.' button - choose	bumps also texture mapping
;;	       planar or spherical (planar according to axis X, Y, Z);
;;	    F6 / 'bumps' - switching between random bumps and texture
;;	       dependent;
;;	    F7 / 'texture' - select  texture: red white stripes, xored face
;;		also blank (witch can by used in smoothing objects edges)
;;		or texture from external file (X key);
;;	    F8 / 'save obj.' - save 3d currently shown object to file
;;	       "object.asc" and "object.3ds";
;;	    F9 / 'cur.segm.' - in Bezier rotated solid	option, also pipes
;;	       and rotated solids & pipes pararell - cyclic switching
;;	       between current segment, current segment marked by green
;;	       frame in two last editing options not works correct now;
;;	    F11 / 'run/stop' button - main rotary on/off;
;;	    F12 / 'rotary' - main rotary cyclic switching - around axis
;;	       X, Y, Z;
;;	    D  / 'do displ.' - do displacement mapping texture dependent;
;;	    T  / 'do triang.' - triangulize objects faces from teslation
;;	       area; it's mean divide each face inside area to four
;;	       smaller faces;
;;	    X - load texture (raw format 512X512 pixels 24bit 0xRRGGBB)
;;	    U  / 'rand. shd.' button - random point (spot) light position
;;	       and obliquity of plane on wihch shadow falls;
;;	    V / 'edit mesh.' button - edit option, posibility to edit
;;	      according to vertex, single face or edge. Use left mouse
;;	      button and yellow handlers;
;;	    W / 'set t. area' button - determine teslation area, only
;;	      triangles that are in this area will be teslated
;;	      (triangulized);
;;	    C / 'set t. col' - set color that will by bypassed when
;;	      teslation occured, options - black, white;
;;	    F / 'dsp. factor' - set diplacement factor, determine bumps
;;	      that make displacement higher or lower;
;;	    B / 'bezier sr.' button - select predefined object, assembled
;;	      using bezier patches;
;;	    A / 'set ap tol' button - set approximation tolerance of adding
;;	      near bezier vertices, some of them are redundant (on tangent
;;	      of bezier patches);
;;	    E / 'b. derives' button - draw bezier derives, selected by B
;;	      key;
;;	    ESC - exit;
;;	    Right mouse button and move - setting position of texture,
;;		  (works in all drawing models, but is visable only in
;;		  texture displaying models).
;;
;;	    After run program shows dialog to open file.
;;	    Choose file in 3ds or asc format and ...admire. ;)
;;
;;
;;
;;				      "No work is ever complete,
;;				       and this one is no exception."
;;							Pierre Bezier
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

format PE GUI 4.0
entry start

include '/include/win32a.inc'
BSEGMENTS = 2	    ; Bezier curve segments count
BPIPES = 1	    ; Bezier pipes count (only in solid and pipes
		    ; pararell editing cause).
BROTSOLIDS =  BSEGMENTS - BPIPES
BXRES	 equ 400 ;1600 ;1200 ;800      ;choose window size of bezier curve editor area
BYRES	 equ 400 ; 900 ; 675 ;450
BSIZE_X  equ BXRES
BSIZE_Y  equ BYRES
MXRES	 equ BXRES  ; menu window size
MYRES	 equ 250 ;BYRES
BROUND	 equ 8

BROTARY_STEPS = BSTEPS	 ; BROTARY_STEPS and BSTEPS  must have the same
		     ; value (both determines object quality|)
BSTEPS = 24


;XRES = 600 ;800 ;1600 ;1200 ;800      ;choose screen size
;YRES = 600  ;450 ;900 ; 675 ;450
;SIZE_X  = XRES
;SIZE_Y  = YRES
TEX_X = 512    ; texture size
TEX_Y = 512
TEXTURE_SIZE EQU (TEX_X * TEX_Y)-1
TEX_SHIFT = 9
TRIANGLES_COUNT equ 4
POINTS_COUNT equ 4
MAX_COUNTER equ 16    ; b_surface.inc  - determines triangles count
ROUND equ 8
NON  = 0  ; --\
MMX  = 1  ;    > this definitions are only for upside down
SSE  = 2  ; --/  compatible reasons
SSE2 = 3
SSE3 = 4
SSE4.1 = 5
AVX = 6
AVX2 = 7
Ext  =	SSE3
;HEAP_MAX_SIZE = 1024 * 1024 * 20 ;1024  ; = 1GB address space.
WM_FINISH equ WM_USER+100h


section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:

    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

     invoke  GetSystemMetrics,SM_CXSCREEN
  ;   mov     eax,1000
     mov     [whole_xres],ax
     sub      eax,MXRES    ; place for menu and bezier curves area
     mov     ebx,eax
     mov     [xres_var],ax
     shr     eax,1
     mov     [xxadd],eax
     invoke  GetSystemMetrics,SM_CYSCREEN
  ;   mov     eax,600
     mov     [whole_yres],ax
     sub     eax,100
     mov     [yres_var],ax
     mov     ecx,eax
     shr     ecx,1
     mov     [yyadd],ecx

     lea     ecx,[ebx-3]
     cvtsi2ss xmm0,ecx
     movss   [max_clip_seg],xmm0
 ;    lea     ecx,[ebx-7]
 ;    cvtsi2ss xmm1,ecx
 ;    movss   [tri_area_x2],xmm1
 ;   tri_area_y2
     lea     ecx,[eax-3]
     cvtsi2ss xmm2,ecx
     movss   [max_clip_seg+4],xmm2

     movzx   eax,[xres_var]
     movzx   ebx,[yres_var]
     sub     eax,6
     sub     ebx,6
     mov     [max_work_x],ax
     mov     [max_work_y],bx
     sub     eax,1
     sub     ebx,1
     cvtsi2ss xmm0,eax
     cvtsi2ss xmm1,ebx
     movss   [tri_area_x2],xmm0
     movss   [tri_area_y2],xmm1

     movzx   eax,[xres_var]
     movzx   ebx,[yres_var]
     mul     ebx
     shl     eax,2
     mov     ebx,eax
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:

    mov     [screen_ptr],eax
    mov     [line_buffer_var],eax
    mov     [lbuffer_ptr],eax



    invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov     [Zbuffer_ptr],eax
    shr     ebx,1
    lea     eax,[ebx*3]   ; maximal buff size for 3 words - face
    invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov     [edit_buf_ptr],eax
    shr     ebx,1
    invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov     [shd_buffer_ptr],eax


    mov   [bmi.biSize],sizeof.BITMAPINFOHEADER
    movzx eax,[xres_var]
    mov   [bmi.biWidth],eax  ;XRES
    movzx edx,[yres_var]

 ;   add   edx,30
    neg   edx

    mov [bmi.biHeight],edx ;-YRES-30
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0


    mov [Bbmi.biSize],sizeof.BITMAPINFOHEADER
    mov [Bbmi.biWidth],BXRES
    mov [Bbmi.biHeight],-BYRES-30
    mov [Bbmi.biPlanes],1
    mov [Bbmi.biBitCount],32
    mov [Bbmi.biCompression],BI_RGB

    mov [Bbmi.biSizeImage],0
    mov [Bbmi.biXPelsPerMeter],0
    mov [Bbmi.biYPelsPerMeter],0
    mov [Bbmi.biClrUsed],0
    mov [Bbmi.biClrImportant],0

    mov [Mbmi.biSize],sizeof.BITMAPINFOHEADER
    mov [Mbmi.biWidth],MXRES
    mov [Mbmi.biHeight],-MYRES ;-30 ;-BYRES-30
    mov [Mbmi.biPlanes],1
    mov [Mbmi.biBitCount],32
    mov [Mbmi.biCompression],BI_RGB

    mov [Mbmi.biSizeImage],0
    mov [Mbmi.biXPelsPerMeter],0
    mov [Mbmi.biYPelsPerMeter],0
    mov [Mbmi.biClrUsed],0
    mov [Mbmi.biClrImportant],0



    mov   [rect.left],0
    mov   [rect.top],0
    movzx eax,[whole_xres]
    mov   [rect.right],eax
    movzx edx,[whole_yres]
    add   edx,30
;    neg edx
    mov   [rect.bottom],edx ;YRES+30

    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0

    invoke RegisterClass,wc



    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left]
    ; rasizable window
    invoke  CreateWindowEx, 0,_class, _title, WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
				0, 0, eax, ecx, NULL, NULL, [wc.hInstance], NULL

;    invoke  CreateWindowEx, 0,_class, _title, WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
;				 CW_USEDEFAULT, CW_USEDEFAULT, eax, ecx, NULL, NULL, [wc.hInstance], NULL
    ; non resizable window
 ;   invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
 ;	    xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW


    ; fix bezier rect files
     mov   ebx,tspoon_rect
     mov   ecx,16+26+32 ; spoon + cup + pot
     shl   ecx,4
   @@:
     sub  word[ebx],1
     add  ebx,2
     sub  ecx,1
     jnz  @b



    pushad
    movzx  eax,[yres_var]  ;YRES / 2
    shr    eax,1
    cvtsi2ss xmm0,eax
    movss  [scale],xmm0

    mov    edi,segments_rotary	 ; zero segment add struct
    xor    eax,eax
    mov    ecx,BSEGMENTS*3
    cld
    rep    stosd


    mov    edi,segments_add	; zero segments add struct
    xor    eax,eax
    mov    ecx,BSEGMENTS*3
    rep    stosd


    mov    edi,menu_screen		 ; zero menu screen
    mov    ecx,MXRES * MYRES
    rep    stosd

;    mov    eax,0x00ffffff
;    mov    ecx,MENU_XRES * MENU_YRES/2
;    rep    stosd


    call   normalize_plane_equation

    call   Binit_derives

    call   open_file
    cmp    [file_ext_flag],0
    jne    @f
    call   read_tp_variables
    call   alloc_mem_for_tp
    call   read_from_file     ; 3ds
    jmp    .norm
  @@:
;    cmp    [file_ext_flag],1
    call   read_asc_tp_variables
    call   alloc_mem_for_tp
    call   read_asc		; asc
  .norm:

    call   prepare_object
    call   normalize_all_light_vectors
  ;  call   calc_p_light_coords
  ;  mov    ebx,shadow_matrix
  ;  mov    esi,point_light_coords
  ;  call   calc_shadow        ; calculate 4x4 shadow matrix

    call   init_envmap2
    call   do_color_buffer
    mov    edi,bump_map
    call   calc_bumpmap
    call   generate_texture2
    call   draw_menu
    popad








;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   msgLoop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
msg_loop:
    stdcall g_draw
    cmp   [edit_flag],0
    je	  @f
    call  clear_edit_buf
    call  write_edit_bars
  @@:
    movzx eax,[ccounter_inc]
    ; if custom rotate

    cmp   [edit_flag],0
    je	  @f
    xor   eax,eax
   @@:
;    cmp   [rotary_flag],3
;    jne   @f
;    push  [custom_obj_angle]
;    pop   eax
;    and   eax,0xff
  @@:
    cmp   [rotary_flag],0
    jne   @f
    add   dword[main_rotary],eax
    and   dword[main_rotary],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],1
    jne   @f
    add   dword[main_rotary+4],eax
    and   dword[main_rotary+4],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],2
    jne   @f
    add   dword[main_rotary+8],eax
    and   dword[main_rotary+8],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],3
    jne   @f
    push  [custom_obj_angle]
    pop   eax
    and   eax,0x00ff00ff
    mov   ebx,eax
    shr   ebx,16
 ;   movq  xmm0,qword[main_rot_base1]
 ;   shufps xmm0,xmm0,11100001b
 ;   movq  [main_rotary],xmm0
    mov   dword[main_rotary],ebx
    and   dword[main_rotary],0xff
    mov   dword[main_rotary+4],eax
    and   dword[main_rotary+4],0xff


  @@:
  .end_rot_inc:

; draw image

    movzx  eax,[xres_var]
    movzx  ebx,[yres_var]
  ;  lea    edx,[ebx];[ebx+30]

    invoke StretchDIBits,[hdc],0,30,eax,ebx,0,0,eax,ebx,[screen_ptr],bmi,0,SRCCOPY


;    call draw_menu
    movzx    eax,[whole_xres]
    mov      ecx,eax
    sub      eax,MXRES

    invoke StretchDIBits,[hdc],eax,0,MXRES,MYRES,0,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY
    cmp    [tex_button_pres],1
    jne    @f

  @@:

    cmp  [hrt_flag],3		 ; hrt_flag indicates what object is current
    jl	 @f

    call   Bdraw_all
    movzx  eax,[whole_xres]
    movzx  ebx,[whole_yres]
    sub    ebx,(100+BYRES) ; 30
    sub    eax,BXRES


     invoke StretchDIBits,[hdc],eax,ebx,BXRES,BYRES,0,0,BXRES,BYRES,Bbuffer,Bbmi,0,SRCCOPY














  @@:
; .no_editor:
    movzx  eax,[draw_flag]
    mov    ebx,36  ; 36 - text chain lenght
    mul    ebx
    add    eax,sh_model
    invoke TextOut,[hdc],10,10,eax,36

    cmp    [edit_flag],0
    jne    @f
    invoke Sleep,2
  @@:
    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop

    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:

    movzx    ebx,[xres_var]
    movzx    eax,[yres_var]
    mul      ebx
    shl      eax,2
    invoke  VirtualFree,[screen_ptr], eax, MEM_DECOMMIT
    call    free_mem_for_tp

    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]










;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
     cmp [wmsg],WM_KEYDOWN
     je .wmkeydown
   @@:
     cmp   [wmsg],WM_LBUTTONDOWN
     jne   .next_mess345
     cmp   [rotary_flag],3
     jne   @f
     mov   eax,[lparam]
     mov   dword[custom_rot_start_x],eax
   ;  movq  xmm0,[main_rotary]
   ;  movq  qword[main_rot_base1],xmm0
   @@:
   ;  cmp   [edit_flag],0
   ;  je    .no_edit
  ;   cmp   [set_tri_area],0
  ;   je    .edit
  ;   jmp   .no_edit
     .edit:
	mov	ebx,[lparam]
	emms
	movd	mm1,ebx
	mov	ebx,30 shl 16 + 1
	movd	mm0,ebx
	movd	mm3,dword[xres_var]
	paddw	mm3,mm0
	pcmpgtw mm0,mm1
	pcmpgtw mm3,mm1
	pxor	mm3,mm0
	movd	eax,mm3
	mov	cx,ax
	shr	eax,16
	and	ax,cx
	or	ax,ax
	jz	.no_edit
	movd	mm0,ebx
	psubw	mm1,mm0

	movd	eax,mm1
	push	eax
       ; eax - position of cursor in "screen/work" area
	cmp    [set_tri_area],0
	jne    .edit_mesh
	movzx  ebx,ax	; check if edition triangulize area
	mov    ecx,eax
	shr    ecx,16
	movzx  edx,word[xres_var]
	imul   edx,ecx
	add    ebx,edx
	lea    ecx,[ebx*2]
	add    ecx,ecx
	add    ecx,[edit_buf_ptr]
	movzx  ecx,word[ecx]
	cmp    ecx,65534
	jne    @f
	mov    [edit_tri_area],1
      @@:
	cmp    ecx,65535
	jne    @f
	mov    [edit_tri_area],2

      ;   cmp	[edit_flag],0
      ;   jne	@f
      ;   cmp	[set_tri_area],0
      ;   je	.no_edit
      ;  call	set_triangulize_rect
    ; @@:
    @@:
      .edit_mesh:
	pop	eax
	xor	edx,edx
	call	edit_init_and_submit

   .no_edit:
     mov   eax,[lparam]
     sub   ax,[whole_xres]
     cmp   ax,-MXRES
     jl    .bez
     ror   eax,16
     cmp   ax,MYRES  ; menu work
     jg    .bez
     ror   eax,16
     mov   esi,menu_data
     mov   eax,[lparam]
     sub   ax,[whole_xres]
     add   ax,MXRES
  @@:
     push  eax
     mov   ecx,[esi+2]
     mov   edx,[esi+6]
     call  xy_in_rect
     pop   eax
     or    ebx,ebx
     jnz   @f
     add   esi,33		; size of one position in menu
     cmp   [esi],word -1	; end mark
     jnz   @b
     jmp  .bez
  @@:
     mov   ax,[esi+2]
     add   ax,2
     shl   eax,16
     mov   ax,[esi+6]
     sub   ax,2
     mov   bx,[esi+4]
     add   bx,2
     shl   ebx,16
     mov   bx,[esi+8]
     sub   bx,2
     mov   [screen_width_var],MXRES
     mov   [lbuffer_ptr],menu_screen
     mov   [line_color],0x0000ff00



     pushad
     call  write_frame
     popad
     mov   word[esi],1	    ;mark button chosen

     movzx    eax,[whole_xres]
     sub      eax,MXRES

     invoke StretchDIBits,[hdc],eax,0,MXRES,MYRES,0,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY

   .bez:
     cmp   [hrt_flag],3
     jl    .next_mess345
     mov   eax,[lparam]
     sub   ax,[whole_xres]  ;XRES-BXRES
     add   ax,BXRES
     ror   eax,16
     sub   ax,[whole_yres]  ;YRES+30-BYRES
     add   ax,BYRES+100
     ror   eax,16
     cmp   ax,BXRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16
     cmp   ax,BYRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16


     movzx ebx,ax
     shr   eax,16
     mov   edx,BXRES
     mul   edx
     add   eax,ebx
     shl   eax,2
     add   eax,Bbuffer
     mov   ebx,[eax]
     and   ebx,0xff000000
     cmp   ebx,0xff000000
     je    .next_mess345
     shr   ebx,24
     mov   [Bcrucial_point],ebx
     mov   [Bmove_flag],1
     jmp   .next_mess345
  @@:
     cmp   [current_seg],255
     je    @f
if 0
     mov   eax,[lparam]
     ror   eax,16
     sub   ax,30

     cmp   ax,[yres_var] ;YRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16
     cmp   ax,[xres_var]  ;XRES
     jg    @f
     cmp   ax,0
     jl    @f
end if
     mov   [seg_rot_flag_button_down],1
  @@:
   .next_mess345:
     cmp   [wmsg],WM_MOUSEMOVE
     jne   .next_msg
;     cmp   [hrt_flag],6
;     jge   .no_rot_solids_and_pipes
     cmp   [rotary_flag],3
     jne   @f
     cmp   [custom_rot_start_x],0
     je    @f
     emms
     movd  mm0,[lparam]
     psubw mm0,qword[custom_rot_start_x]
     psrlw mm0,2
     movd  [custom_obj_angle],mm0
  @@:
     cmp   [edit_tri_area],0
     je    @f
	mov	ebx,[lparam]
	emms
	movd	mm1,ebx
	mov	ebx,30 shl 16 + 1
	movd	mm0,ebx
	psubw	mm1,mm0
	pmaxsw	mm1,qword[min_work_x]
	pminsw	mm1,qword[max_work_x]
	movd	eax,mm1
	call	set_triangulize_rect
     @@:
    cmp    [tex_button_pres],1
    jne    @f

    movd   xmm0,[lparam]
    movd   xmm1,[tex_mov_begin_x]
    psubw  xmm1,xmm0
    movd   eax,xmm1
    movd   [tex_mov_begin_x],xmm0
    mov    ebx,eax
    sar    ebx,16
    cwde
    call   move_texture
  @@:
     cmp   [edit_vertex_no],0
     jne   @f
     cmp   [edit_edge_no],0
     jne   @f
     mov   eax,dword[edit_face_no]   ; only two indexes, 3rd to done !
     or    eax,eax
     jz   .next_one
   @@:









     emms
     movd  mm0,[lparam]
 ;    mov   ebx,1 shl 16 + 1
 ;    movd  mm2,ebx
 ;    psubw mm0,mm2
     mov   eax,30 shl 16 + 0
     movd  mm1,eax
     psubw mm0,mm1
     pmaxsw  mm0,qword[min_work_x]
     pminsw  mm0,qword[max_work_x]

     movd  dword[edit_end_x],mm0
   ;  call edit_move
   .next_one:
     cmp   [seg_rot_flag_button_down],1
     jne   .Bezier_mov
     cmp   [hrt_flag],3
     jge   @f
     jmp   .Bezier_mov
   @@:
     cmp   [hrt_flag],6
     jge   .Bezier_mov
     mov   eax,[lparam]    ; rotate single segment of bezier
					    ; rotated solid
     ror   eax,16
     sub   ax,100
     movzx ebx,ax
     shr   eax,16
     movzx ecx,[current_seg]
     shl   ecx,2
     lea   ecx,[ecx*3]
     and   eax,0xff
     and   ebx,0xff
     mov   [segments_rotary+ecx],eax
     mov   [segments_rotary+ecx+4],ebx
     pushad
     call  Bdraw_all
     popad
     cmp   [hrt_flag],3
     jne   @f
     call  save_object
     jmp   .Bezier_mov
   @@:
     cmp   [hrt_flag],4
     jne   @f
     call  save_pipe
     jmp   .Bezier_mov
   @@:
     call  save_pipe_rot_solid
   .Bezier_mov:
     cmp   [Bmove_flag],1
     jne   .next_msg
     cmp   [hrt_flag],6
     jge   .next_msg
     mov   ecx,[lparam]
     mov   ax,[whole_xres]
     sub   ax,BXRES
     cmp   cx,ax  ;XRES-BXRES
     jl    .next_msg
     ror   ecx,16
     mov   bx,[whole_yres]
     sub   bx,BYRES
     sub   bx,100
     cmp   cx,bx  ;YRES+30-BYRES
     jl    .next_msg
     sub   cx,bx   ;YRES+30-BYRES
     ror   ecx,16
     sub   cx,ax   ;XRES-BXRES

     mov   ebx,[Bcrucial_point]
     cmp   ebx,253		   ; check if axis
     jae   @f
     shl   ebx,2
     mov   [ebx+Biderives],ecx
     jmp   .draw
    @@:
     sub   ebx,253
     shl   ebx,2
     mov   [ebx+Bix1_axis],ecx
   .draw:
     pushad
     call  Bdraw_all
     popad
     cmp   [hrt_flag],4
     jne   @f
     call  save_pipe	    ; save changes - on the fly write to points / triangles lists
     jmp   .next_msg
   @@:


     cmp   [hrt_flag],5
     jne   @f

     call  save_pipe_rot_solid
     jmp  .next_msg
   @@:
     call  save_object	 ; if hrt_flag = 3 save solid rotared curve

 ; .no_rot_solids_and_pipes:	 ; no job with rotated solids and pipes

  .next_msg:
     cmp   [wmsg],WM_LBUTTONUP
     jne   .rbutd
     mov   [custom_rot_start_x],0
     mov   [edit_tri_area],0
     cmp    [edit_vertex_no],0
     jne    @f
     mov    eax,dword[edit_face_no]
     or     eax,eax   ; only two indexes, third to done !
     jne    @f
     cmp    [edit_edge_no],0
     jne    @f
     jmp    .segment_rot
  @@:
     emms
     movd  mm0,[lparam]
 ;    mov   ebx,1 shl 16 + 1
 ;    movd  mm2,ebx
 ;    psubw mm0,mm2
     mov   eax,30 shl 16 + 0
     movd  mm1,eax
     psubw mm0,mm1
     movd  eax,mm0

     mov    edx,1
     call   edit_init_and_submit
     mov    [edit_vertex_no],0
     mov    [edit_edge_no],0
     pxor   mm3,mm3
     movq   [edit_face_no],mm3
     mov    dword[edit_end_x],0
     mov    dword[edit_start_x],0
   .segment_rot:

     mov   [seg_rot_flag_button_down],0
     mov   [Bmove_flag],0

     ; GUI buttons work
     mov   eax,[lparam]     ; check if sth in menu marked
     sub   ax,[whole_xres]
     cmp   ax,-MXRES
     jl    .dr_mn
     ror   eax,16
     cmp   ax,MYRES
     jg    .dr_mn
     ror   eax,16
     mov   esi,menu_data
     mov   eax,[lparam]
     sub   ax,[whole_xres]
     add   ax,MXRES
  @@:
     push  eax
     mov   ecx,[esi+2]
     mov   edx,[esi+6]
     call  xy_in_rect
     pop   eax
     or    ebx,ebx
     jnz   @f
     add   esi,33		; size of one position in menu
     cmp   [esi],word -1
     jnz   @b
     jmp  .dr_mn
  @@:
     cmp   word[esi],1
     jne   .dr_mn
     ; this button was pressed (pointed in esi)
			    ; update flags
     mov   word[esi],0	    ; mark
     mov   al,byte[esi+22]
     inc   al
     cmp   al,[esi+21]
     jne   @f
     xor   al,al
   @@:
     mov   [esi+22],al
     mov   ax,[esi+27]
     mov   [menu_button_number],ax
   .dr_mn:

;     mov    edi,menu_screen
;     mov    ecx,MXRES*MYRES
;     xor    eax,eax
;   @@:
;     mov    [edi],eax

     call   draw_menu
if 0
     mov   ax,[esi+2]
     add   ax,2
     shl   eax,16
     mov   ax,[esi+6]
     add   ax,2
     mov   bx,[esi+4]
     sub   bx,2
     shl   ebx,16
     mov   bx,[esi+8]
     sub   bx,2
     mov   [screen_width_var],MXRES
     mov   [lbuffer_ptr],menu_screen
     mov   [line_color],0x00000000
     pushad
     call  write_frame
     popad
     mov   word[esi],0	    ;mark
end if

  .rbutd:
    cmp   [wmsg],WM_RBUTTONDOWN
    jne   @f



if 0	  ; triangulize work
	mov	ebx,[lparam]
	emms
	movd	mm1,ebx
	mov	ebx,30 shl 16 + 1
	movd	mm0,ebx
      ;  movd	 mm1,[lparam]
	movd	mm3,dword[x_trianglize]
	paddw	mm3,mm0
	pcmpgtw mm0,mm1
	pcmpgtw mm3,mm1
	pxor	mm3,mm0
	movd	eax,mm3
	mov	cx,ax
	shr	eax,16
	and	ax,cx
	or	ax,ax
	jz	.no_edit
	movd	mm0,ebx
	psubw	mm1,mm0
	movd	eax,mm1
       ; eax - position of cursor in "screen/work" area
	xor	edx,edx
	call	edit_init_and_submit

end if





    mov   [tex_button_pres],1
    mov   eax,[lparam]
    mov   [tex_mov_begin_x],eax

  @@:
    cmp   [wmsg],WM_RBUTTONUP
    jne   @f
    mov   [tex_button_pres],0
    jmp   .next_1
  @@:
if 0
    cmp    [wmsg],WM_MOUSEMOVE
    jne    @f
    cmp    [tex_button_pres],1
    jne    @f

    movd   xmm0,[lparam]
    movd   xmm1,[tex_mov_begin_x]

    psubw  xmm1,xmm0
    movd   eax,xmm1
    movd   [tex_mov_begin_x],xmm0
    mov    ebx,eax
    sar    ebx,16
    cwde
    call   move_texture
end if
   @@:

 .next_1:

    cmp    [wmsg],WM_DESTROY
    je	   .wmdestroy

  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp    .finish

  .wmkeydown:
    cmp   [wparam],VK_UP
    jne   @f
    xor   eax,eax
    jmp   .finish
  @@:

    mov   eax,[wparam]
    call  update_flags_after_keypress

    cmp   [wparam],0x58 ;  'x'
    jne   @f
    call   open_texture
  @@:
  ;  mov   ecx,[wparam]
  ;  int3
    cmp   [wparam],VK_ESCAPE
    jne   .finish

  .wmdestroy:
    invoke PostQuitMessage,0
    xor    eax,eax

  .finish:    ; GUI buttons
    cmp   [menu_button_number],3  ; zoom in
    jne   @f
    fninit
    fld   [scale]
    fmul  [scale_plus]
    fstp  [scale]
    jmp   .end
  @@:
    cmp   [menu_button_number],4  ; zoom out
    jne   @f
    fninit
    fld   [scale]
    fmul  [scale_minus]
    fstp  [scale]
    jmp   .end
  @@:

if 0
    cmp   [menu_button_number],18
    jne   @f
    call  set_tri_area
  @@:
end if




    cmp   [menu_button_number],5  ; tex map
    jne   @f	     ; bump, texture - spherical or planar mapping
    call  calc_bumpmap_coords
    jmp   .end
  @@:
    cmp   [menu_button_number],6  ; random directional lights
    jne   @f
    call  make_random_lights
    call  normalize_all_light_vectors
 ;   call  calc_p_light_coords
    call  do_color_buffer
    call  init_envmap2
    jmp   .end
   @@:
    cmp   [menu_button_number],7  ; displaying models
    jne   @f
    movzx  eax,[xres_var]
    invoke StretchDIBits,[hdc],0,0,eax,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
    jmp   .end
  @@:
    cmp   [menu_button_number],8  ; bumps random/texture dependent
    jne   @f
    call  calc_bumpmap
  @@:
    cmp   [menu_button_number],9  ; bumps random/texture dependent
    jne   .next_no
    cmp   [tex_flag],0
    jne   @f
    call  generate_texture2    ; draw stripes
    jmp   .tex_end
  @@:
    cmp   [tex_flag],1
    jne   @f
    call  generate_texture3	; draw xor
    jmp   .tex_end
  @@:
    call  generate_texture1	; white area
  .tex_end:
    call  calc_bumpmap
  .next_no:
    cmp   [menu_button_number],10  ; save 3d object
    jne   @f
    call  write_asc
    call  save3ds
    jmp   .end
  @@:
    cmp   [menu_button_number],12  ; active segment chosen
    jne   .seg_ch_end
    cmp   [hrt_flag],3
    jl	  .seg_ch_end
    inc   [current_seg]
    cmp   [current_seg],BSEGMENTS
    jne   @f
    mov   [current_seg],0
  @@:
    pushad
    call  Bdraw_all
    popad
    cmp  [hrt_flag],3
    jne  @f
    call save_object
    jmp   .end
  @@:
    cmp   [hrt_flag],4
    jne   @f
    call  save_pipe
    jmp   .end
  @@:
    call  save_pipe_rot_solid
    jmp  .end
  .seg_ch_end:
;    cmp   [menu_button_number],13  ; load texture
;    jne   @f
;    call  open_texture
;    jmp   .end
;   @@:

    cmp   [menu_button_number],13  ; do displacement
    jne   @f
    pushad
    call  apply_displacement_from_tex
    popad
    call   prepare_object
    jmp   .end
   @@:


    cmp   [menu_button_number],14  ; do teslation
    jne   .triang_end
    cmp   [points_count_var],16000  ; 65536/4 - max triangles,
    jg	  .triang_end		   ;	     vertexes count
    cmp   [triangles_count_var],16000
    jg	  .triang_end
    pushad
    call  triangulize_all_faces
    popad
    mov   [tp_mem_alloc],1
    call  alloc_mem_for_tp
    mov   [tp_mem_alloc],0
    call   prepare_object
    jmp   .end
  .triang_end:


    cmp   [menu_button_number],15  ; current object
    jne   .active_obj_end
  .active_object_do:
    cmp   [hrt_flag],1
    jne   @f
    call  read_hrt
    call   prepare_object
    jmp    .end

  @@:
    cmp   [hrt_flag],2
    jne    @f
    call   load_tetrahedron
    call   prepare_object
    jmp    .end

  @@:
     cmp   [hrt_flag],3
     jne   @f
     mov   [triangles_count_var],BROTARY_STEPS*BSTEPS*BSEGMENTS*2
     mov   [points_count_var],BROTARY_STEPS*BSTEPS*BSEGMENTS*5/4
     call  alloc_mem_for_tp
     pushad
     call  Bdraw_all
     popad
     call  save_object	      ; save changes - on the fly write to points / triangles lists
     call  prepare_object
     jmp   .end

 @@:
     cmp   [hrt_flag],4
     jne   @f
     pushad
     call  Bdraw_all
     popad
     call  save_pipe	    ; save changes - on the fly write to points / triangles lists
     call  prepare_object
     jmp   .end

  @@:
     cmp   [hrt_flag],5
     jne   @f
     pushad
     call  Bdraw_all
     popad
     call  save_pipe_rot_solid	     ; save changes - on the fly write to points / triangles lists
     call  prepare_object
     jmp   .end
  @@:











    cmp    [file_ext_flag],0
    jne    @f
    pushad
    call   read_tp_variables  ; 3ds
    call   alloc_mem_for_tp
    call   read_from_file
    popad
    call   prepare_object
    jmp    .end
   @@:
    call   read_asc_tp_variables  ; asc
    call   alloc_mem_for_tp
    call   read_asc
    call   prepare_object
    jmp   .end
  .active_obj_end:

    cmp   [menu_button_number],16  ; random point light position
    jne   @f			   ; and plane equation
    call   random_point_light_position
    call   normalize_plane_equation
    jmp   .end
  @@:
;    cmp   [menu_button_number],18  ; triangukize area/rect
;    jne   @f			    ;
;    call   set_triangulize_rect
;    jmp   .end
  @@:
    cmp   [menu_button_number],19  ; transparent displacement color
    jne   .next
    cmp   [disp_col_flag],0
    jne   @f
    mov   [displ_transparent_col],0x00ffffff
  @@:
    cmp   [disp_col_flag],1
    jne   @f
    mov   [displ_transparent_col],0
  @@:
    jmp   .end
  .next:




     ; ********check if draw bezier surfaces****************************
     cmp   [menu_button_number],21
     jne   .no_bez
     cmp   [bezier_flag],1
     jne   @f
     push  dword tpot_rect
     pop   dword[derv_rect_ptr]
     push  dword tpot_nodes
     pop   dword[derv_nodes_ptr]
     mov   [bez_patch_count],32  ;26  ;16
     mov   [bez_nodes_count],306
     jmp   .forward_bez
   @@:
     cmp   [bezier_flag],2
     jne   @f
     push  dword tcup_rect
     pop   dword[derv_rect_ptr]
     push  dword tcup_nodes
     pop   dword[derv_nodes_ptr]
     mov   [bez_patch_count],26  ;16
     mov   [bez_nodes_count],251
     jmp   .forward_bez
   @@:
     cmp   [bezier_flag],3
     jne  .active_object_do
     push  dword tspoon_rect
     pop   dword[derv_rect_ptr]
     push  dword tspoon_nodes
     pop   dword[derv_nodes_ptr]
     mov   [bez_patch_count],16
     mov   [bez_nodes_count],256

   .forward_bez:


     mov   [triangles_count_var],32*32*32
     mov   [points_count_var],32*32*32
     call  alloc_mem_for_tp

    pushad
    push  [derv_nodes_ptr]
    movzx ecx,[bez_nodes_count]
    push  ecx
    call  normalize_object1
    popad

 ;   call  clear_edit_buf

;  in esi - ptr to derives
;     edi - derive vertices list
;     ebx - derive indexes list
;     ecx - number of surfaces
if 0
     mov   esi,bssurface_derives
     mov   edi,derives_vertices
     mov   ebx,derives_indexes
     movzx ecx,[bez_patch_count]
     call  do_derives_lists
end if
if 1
;     unpack list
    ;  bssurface_derv_unpacked

     mov   ebx,[derv_rect_ptr]	 ;  ;derives_indexes
     mov   edi,bssurface_derv_unpacked
     mov   esi,[derv_nodes_ptr]   ;derives_vertices
     movzx ecx,[bez_patch_count]
     shl   ecx,4
  @@:
     movzx   eax,word[ebx]
     imul    eax,[i12]
     add     eax,esi
     movups  xmm0,[eax]
     movlps  [edi],xmm0
     movhlps xmm0,xmm0
     movss   [edi+8],xmm0
     add     edi,12
     add     ebx,2
     sub     ecx,1
     jnz     @b

end if
if 0

     pushad
     push  dword bssurface_derv_unpacked
     movzx ecx,[bez_patch_count]
     shl   ecx,4
     push  ecx
     call  normalize_object1
     popad

end if



;	esi - ptr  -> x11, y11, z11 .... x44, y44, z44 ; dword
;	edx - quality -> s shl 16 t
;	edi - ptr to area of calculated vertices
;	ebx - ptr to area of calculated faces (triangles)
;  out :
;	ecx - vertices count
;	edx - triangles count
if 1
     mov    [points_count_var],0
     mov    [triangles_count_var],0

     mov   esi,bssurface_derv_unpacked	 ;bssurface_derives
     mov   edi,[points_r_ptr]
     mov   ebx,[triangles_ptr]
     push  ebp
     mov   ebp,esp
     sub   esp,16
     .bez_cnt	equ dword[ebp-4]
     .cur_tri_l equ dword[ebp-8]
     mov   .bez_cnt, 0	 ; counter
     mov   .cur_tri_l,0

;     mov    eax,.bez_cnt  ;[derives_inde



   .bez_again:

     mov    edx,8 shl 16 + 8
     push   ebx
     push   esi
     call   calc_bezier_surface 	 ; calc_bssurface
     add    [points_count_var],cx
     add    [triangles_count_var],dx
     pop    esi  ; esi - derives
     add    esi,12*16
     pop    .cur_tri_l
     add    .bez_cnt,1
     cmp    .bez_cnt,1
     jz     .bez_again

;  .bez_again2:
	 ; modify triangles_list
     push   ebx  ; ebx - cur tri ptr
     push   ecx
     push   edx
     movzx  ecx,cx
     mov    ebx,.bez_cnt
     sub    ebx,1
     imul   ecx,ebx   ;.bez_cnt
     mov    ebx,.cur_tri_l
  ;	 cx - vertex count, pro one patch
  ;	 dx - cur triangles count ( pro one patch )

   @@:
     add    [ebx],cx
     add    [ebx+2],cx
     add    [ebx+4],cx
     add    ebx,6
     sub    dx,1
     jnz    @b

     pop    edx
     pop    ecx
     pop    ebx
     movzx  eax,[bez_patch_count]
     cmp    .bez_cnt,eax
     jne    .bez_again

end if

if 0
   ; I tried implement version that uses nodes
   ; and rects only without unpacking all
     mov    [points_count_var],0
     mov    [triangles_count_var],0

;     mov	 esi,[derv_nodes_ptr]  ;bssurface_derv_unpacked   ;bssurface_derives
     push	 ebp
     mov	 ebp,esp
     sub	 esp,16
     .bez_cnt	 equ dword[ebp-4]
     .cur_tri_l  equ dword[ebp-8]
     .prev_tri_l equ dword[ebp-12]
;     .cur_vert   equ dword[ebp-16]
     mov   .bez_cnt, 0	 ; counter
     mov   .cur_tri_l,0

     mov       ebx,dword[triangles_ptr]
   ;  pop	 .cur_tri_l
;     push	 dword[points_r_ptr]
;     pop	 .cur_vert
     mov    .cur_tri_l,ebx
     mov    edi,[points_r_ptr]
   .bez_again:
     push   ebx
     mov    ebx,.bez_cnt
     shl    ebx,6
     add    ebx,[derv_rect_ptr]
     xor    edx,edx
  @@:
     movzx  eax,word[ebx]
     imul   eax,[i12]
     add    eax,[derv_nodes_ptr]
     movups xmm0,[eax]
     movhlps xmm1,xmm0
     movq   qword[one_bez_patch_unpacked+edx],xmm0
     movss  dword[one_bez_patch_unpacked+8+edx],xmm1
     add    edx,12
     add    ebx,2
     cmp    edx,12*16
     jnz    @b
     pop    ebx

;     pushad
;     push  dword one_bez_patch_unpacked
;     mov   ecx,16
;     push  ecx
;     call  normalize_object1
;     popad

     mov    esi,one_bez_patch_unpacked
     mov    edx,8 shl 16 + 8
     push   ebx
     mov    ebx,.cur_tri_l
     call   calc_bezier_surface 	 ; calc_bssurface

  ; ebx - end of computed triangles list ptr
  ; edi - end of calculated vertices ptr

     add    [points_count_var],cx
     add    [triangles_count_var],dx
     pop    .cur_tri_l

     add    .bez_cnt,1
     cmp    .bez_cnt,1
     jz     .bez_again

;     add    .bez_cnt,1
;     movzx   eax,[bez_patch_count]
;     cmp    .bez_cnt,eax
;     jz     .bez_again


	 ; modify triangles_list
     push   ebx  ; ebx - cur tri ptr
     push   ecx
     push   edx
     movzx  ecx,cx
     mov    ebx,.bez_cnt
     sub    ebx,1
     imul   ecx,ebx   ;.bez_cnt
     mov    ebx,.cur_tri_l
  ;	 cx - vertex count, pro one patch
  ;	 dx - cur triangles count ( pro one patch )

   @@:
     add    [ebx],cx
     add    [ebx+2],cx
     add    [ebx+4],cx
     add    ebx,6
     sub    dx,1
     jnz    @b

     pop    ebx
     pop    edx
     pop    ecx
     movzx  eax,[bez_patch_count]
     cmp    .bez_cnt,eax
     jne    .bez_again


end if








  .end_bez:
 ; remove redundant vertices witch are on border of each 'sticked' patch
      cmp   [tolerancy_flag],0
      jne   @f
      mov   eax,0.009
      jmp   .rem_red
    @@:
      cmp   [tolerancy_flag],1
      jne   @f
      mov   eax,0.0009
      jmp   .rem_red
    @@:
      cmp   [tolerancy_flag],2
      jne   @f
      mov   eax,0.00009
      jmp   .rem_red

   .rem_red:
      call  remove_redundant_vert



      call   init_triangles_normals2
      call   init_point_normals
      call   calc_bumpmap_coords

      add    esp,16
      pop    ebp
     jmp   .end
  .no_bez:



    cmp   [menu_button_number],20  ; displacement factor
    jne   .next1
    cmp   [disp_fac_flag],0
    jne   @f
    mov   [displac_div],6800
  @@:
    cmp   [disp_fac_flag],1
    jne   @f
    mov   [displac_div],8000
  @@:
    cmp   [disp_fac_flag],2
    jne   @f
    mov   [displac_div],10000
  @@:
    cmp   [disp_fac_flag],3
    jne   @f
    mov   [displac_div],15000
  @@:

  .next1:
    jmp   .end
  @@:

  .end:
    mov   [menu_button_number],0
    ret

endp

;******************************************************
;*****************			***************
;*****************  Various procedures	***************
;*****************			***************
;******************************************************

prepare_object:
    pushad
    push   dword [points_r_ptr]
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords
ret

update_flags_after_keypress:
  ;   in ax - wparam
     pushad
     mov   esi,menu_data
   @@:
     cmp   word[esi+29],ax
     je    .updat
     cmp   word[esi+31],ax
     je    .updat
     add   esi,33
     cmp   word[esi],-1
     jnz   @b
     jmp   .end
  .updat:
     mov   al,byte[esi+22]
     inc   al
     cmp   al,[esi+21]
     jne   @f
     xor   al,al
   @@:
     mov   [esi+22],al
     mov   ax,[esi+27]
     mov   [menu_button_number],ax

     mov    edi,menu_screen
     mov    ecx,MXRES*MYRES
     xor    eax,eax
   @@:
     mov    [edi],eax
     sub    ecx,1
     jnz    @b
     call   draw_menu
   .end:
     popad
ret


open_texture:

   mov	   [ofntex.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofntex
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fnametex,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfiletex],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfiletex],0
   cmp	   eax,-1
   je	   .failed
   cmp	   eax,TEX_X*TEX_Y*3
   jnae    .failed
   mov	   [FileSize],eax
   cmp	   [pmemtex],0
   jne	   .heap_realloc
   invoke  GetProcessHeap
   mov	   [hheap],eax
   invoke  HeapAlloc,[hheap],0,[FileSize]
   jmp	   .read_file

 .heap_realloc:
   invoke  HeapReAlloc,[hheap],0,[pmem],[FileSize]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; read raw file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 .read_file:	  ; read texture
   mov	   [pmemtex],eax
   mov	   ebx,eax
   invoke  ReadFile,[hfiletex],[pmemtex],[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfiletex]
   mov	   [hfiletex],0

   mov	   esi,[pmemtex]  ;ebx
   mov	   edi,texmap
   cld

   mov	    ecx,TEX_X*TEX_Y  ;eax

   xor	    eax,eax
 @@:
   movsw
   movsb
   stosb
   loop  @b

   mov	   eax,[BytesRead]
  .init_ptr:
   mov	   [File_tex_ptr],ebx
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret


 .read_error:
   invoke  HeapFree,[hheap],0,[pmemtex]
   mov	   [pmemtex],0

 .failed:
   cmp	   [hfiletex],0
   je	   @f
   invoke  CloseHandle,[hfiletex]
  @@:
   invoke  MessageBox,[hwnd],_notraw,0,MB_OK
   .cancel:
ret


open_file:

   mov	   [ofn.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofn
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfile],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfile],0
   cmp	   eax,-1
   je	   .failed
   mov	   [FileSize],eax
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   mov	   [File_ptr],eax
   invoke  ReadFile,[hfile],eax,[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfile]
   mov	   [hfile],0

   mov	   eax,[BytesRead]
   mov	   ebx,[File_ptr]
   mov	   cx,WORD [ebx]
   cmp	   cx,'MM'
   je	  @f
   mov	   [file_ext_flag],1  ; asc
   jmp	   .init_ptr
 @@:
   mov	   [file_ext_flag],0
 .init_ptr:
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret
 .read_error:
 .failed:
   cmp	   [hfile],0
   je	   @f
   invoke  CloseHandle,[hfile]
  @@:
   invoke  MessageBox,[hwnd],_not3ds,0,MB_OK
   .cancel:
   invoke  ReleaseDC,[hwnd],[hdc]
   invoke  DestroyWindow,[hwnd]
   invoke  ExitProcess,[msg.wParam]
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer; main program proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw ;uses ebx esi edi
local .temp dw ?, .rot_flag dw ?
;local .first_p_index dd ?, .second_p_index dd ?, .third_p_index dd ?
;local .zz1 dw ?, .zz2 dw ?, .zz3 dw ? ;-> don't change order
local .zz1f dd ?, .zz2f dd ?,.zz3f dd ?
local .xx1f dd ?,.xx2f dd ?,.xx3f dd ?
local .yy1f dd ?,.yy2f dd ?,.yy3f dd ?
local .xx1 dw ?, .xx2 dw ?, .xx3 dw ?
local .yy1 dw ?, .yy2 dw ?, .yy3 dw ?
local .xy1 dd ?, .xy2 dd ?, .xy3 dd ?
local .dpr dd ?, .dpr_p dd ?
local .x_temp_var dd ?, .y_temp_var dd ?
local .counter dd ?
local .sinx dd ?, .cosx dd ?
local .siny dd ?, .cosy dd ?
local .sinz dd ?, .cosz dd ?
;local .matrix rb 36
local .shadow_matrix rb 64
local .dot_pr_light   dd ?
;local .p_light_vec rd 4
local .shd_vertices rd	12
;local .shd_counter dd ?
; local .temp_vect dqword ?
    pushad
    cmp   [blur_flag],1
    jne   @f
    xor   eax,eax	   ; clear draw buffer
    mov   edi,[screen_ptr]
    movzx ebx,[xres_var]
    movzx ecx,[yres_var]
    imul  ecx,ebx
    call  fill_aligned
    jmp   .no_blur
  @@:
    mov   ecx,1
    call  blur_screen
  .no_blur:
    cmp   [draw_flag],10
    je	  @f
    mov   eax,5000*65536    ; make background to Zbuffer
    jmp   .m_back
  @@:
    mov   eax,6000.1
  .m_back:
    mov   edi,[Zbuffer_ptr]
    movzx ecx,[xres_var]
    movzx ebx,[yres_var]
    imul  ecx,ebx
    call  fill_aligned

  .rotate:
if 1
   fninit
   fld	 [one_deg]
   fld	 st
   fimul dword[main_rotary+8]	; z
   fsincos
   fstp  [.sinx]
   fstp  [.cosx]
   fld	 st
   fimul dword[main_rotary] ; x
   fsincos
   fstp  [.siny]
   fstp  [.cosy]
   fimul dword[main_rotary+4] ; y
   fsincos
   fstp  [.sinz]
   fstp  [.cosz]

   pushad
   push   [.sinx]
   push   [.cosx]
   push   [.siny]
   push   [.cosy]
   push   [.sinz]
   push   [.cosz]
   lea	  edi,[matrix]
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   push   ebp
   mov	  esi,[points_normals_ptr]	     ; rotate normals
   mov	  edi,[points_normals_rotated_ptr]
   movzx  ecx,[points_count_var]
   lea	  ebx,[matrix]
   call   rotary
   pop ebp




   push   ebp
   lea	esi,[matrix] ;esi - pointer to 3x3 matrix
   mov	ebx,scale     ;ebx - ptr to scale
   call add_scale_to_matrix

   cmp	  [bezier_flag],0
   je	  .no_bez_rot


;   push   ebp
;   mov    esi,bssurface_derv_unpacked ; bssurface_derives
;    ; rotate bezier surf. derives
;   mov    edi,bssurface_derives_rotated
;   movzx  ecx,[bez_patch_count]
;   shl    ecx,4
;   lea    ebx,[matrix]
;   call   rotary
;   pop ebp


   push   ebp
   mov	  esi,[derv_nodes_ptr] ; bssurface_derives
    ; rotate bezier surf. nodes
   mov	  edi,derv_nodes_rot
   movzx  ecx,[bez_nodes_count]
   lea	  ebx,[matrix]
   call   rotary
   pop ebp

if 0
    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    xor      ecx,ecx
    movzx    eax,[bez_patch_count]
    shl      eax,4
    mov      ebx,bssurface_derives_rotated
  @@:
    movups   xmm1,[ebx]
 ;   mulps    xmm1,xmm2
    addps    xmm1,xmm3
    movlps   [ebx],xmm1
    movhlps  xmm1,xmm1
    movss    [ebx+8],xmm1
    add      ebx,12
    add      ecx,1
    cmp      ecx,eax
    jnz      @b
end if

    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    xor      ecx,ecx
    movzx    eax,[bez_nodes_count]
    mov      ebx,derv_nodes_rot  ;bssurface_derives_rotated
  @@:
    movups   xmm1,[ebx]
 ;   mulps    xmm1,xmm2
    addps    xmm1,xmm3
    movlps   [ebx],xmm1
    movhlps  xmm1,xmm1
    movss    [ebx+8],xmm1
    add      ebx,12
    add      ecx,1
    cmp      ecx,eax
    jnz      @b








 .no_bez_rot:

   lea	  ebx,[matrix]
   movzx  ecx,[points_count_var]
   mov	  esi,[points_r_ptr]
   mov	  edi,[points_rotated_ptr]
   call   rotary
   pop	  ebp




end if
    cmp    [draw_flag],0
    jne    .no_shadow
    ;  draw background image
	pushad
	push	[yres_var]
	push	word 0
	push	word 5500
	push	word 5500
	push	word 5500
	push	dword 1 * 65536 + 511
	push	dword 511 * 65536 + 1
	push	dword 1 * 65536 + 1

	mov    eax, 1 * 65536 + 1
	mov    bx, [xres_var]
	shl    ebx,16
	mov    bx, 1
	mov    ecx, 1 * 65536
	mov    cx,[yres_var]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	push	[yres_var]
	push	word 0
	push	word 5500
	push	word 5500
	push	word 5500
	push	dword 1 * 65536 + 511
	push	dword 511 * 65536 + 511
	push	dword 511*65536 + 1

	mov    ax,[xres_var]
	shl    eax,16
	mov    ax,1
	mov    bx, [xres_var]
	shl    ebx,16
	mov    bx, [yres_var]
	mov    ecx, 1 * 65536
	mov    cx,[yres_var]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z
	popad


	;make background in shd buff
	movzx eax,[xres_var]
	movzx ecx,[yres_var]
	mul   ecx
	mov   ecx,eax
	shr   ecx,2
	xor   eax,eax
	mov   edi,[shd_buffer_ptr]
	cld
	rep   stosd


	movzx ecx,[triangles_count_var]
	mov   esi,[triangles_ptr]

   .again_shd_tri:
	push   esi
	push   ecx
	mov    [shd_counter],0
      .next_shd_vert:
	mov	eax,[shd_counter]
	movzx	edx,word[eax*2+esi]
	imul	edx,[i12]
	add	edx,[points_rotated_ptr]  ; [edx] - cur vertex
	movups	xmm0,[edx]
	andps	xmm0,[zero_hgst_dd]
	subps	xmm0,[point_light_coords]
	movaps	xmm1,xmm0
	mulps	xmm1,xmm1
	haddps	xmm1,xmm1
	haddps	xmm1,xmm1
    ;	 shufps  xmm1,xmm1,0
	andps	xmm1,[zero_hgst_dd]
	rsqrtps xmm1,xmm1
	mulps	xmm0,xmm1    ; xmm0 - normalized light vector
	andps	xmm0,[zero_hgst_dd]
	movups	[p_light_vec],xmm0  ;+eax

	pushad
	lea    ebx,[.shadow_matrix]
	lea    esi,[p_light_vec]   ; +eax
	call   calc_shadow	  ; calculate 4x4 shadow matrix
	popad
	pushad
	mov    esi,edx
	mov    ecx,1
	mov    eax,[shd_counter]
	shl    eax,4
	lea    ebx,[.shadow_matrix]
	lea    edi,[.shd_vertices]
	add    edi,eax
	call   mul_matrix4x4
	popad
	add    [shd_counter],1
	cmp    [shd_counter],3
	jnz    .next_shd_vert

	lea	 ebx,[.shd_vertices]
	movups	 xmm0,[ebx]
	movdqu	 xmm3,[xxadd]
	movups	 xmm1,[ebx+16]
	movups	 xmm2,[ebx+32]

	cvtps2dq xmm0,xmm0
	cvtps2dq xmm1,xmm1
	cvtps2dq xmm2,xmm2
	paddd	 xmm0,xmm3
	paddd	 xmm1,xmm3
	paddd	 xmm2,xmm3

	packssdw xmm0,xmm0
	packssdw xmm1,xmm1
	packssdw xmm2,xmm2
	movd	 eax,xmm0
	movd	 ebx,xmm1
	movd	 ecx,xmm2
	ror	 eax,16
	ror	 ebx,16
	ror	 ecx,16
	mov	 edx,0xffafafaf
	mov	 edi,[screen_ptr]
	mov	 esi,[shd_buffer_ptr]

	pushad
	call	triangle_shd
   if 0
	pushad
	push	word 500
	push	word 500
	push	word 500
	push	dword 1 * 65536 + 1
	push	dword 1 * 65536 + 1
	push	dword 1 * 65536 + 1

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z
	popad
    end if
    if 0
	push  word 500
	push  dword 10 shl 16 + 10
	push  word 10
	push  word 500
	push  dword 10 shl 16 + 10
	push  word 10
	push  word 500
	push  dword 10 shl 16 + 10
	push  word 10
	mov   esi,[Zbuffer_ptr]
	mov   edi,[screen_ptr]
	call  gouraud_triangle_z
     end if

      ;  pop	 ebp
	popad
	pop	ecx
	pop	esi
	add	esi,6
	dec	ecx
	jnz    .again_shd_tri


.no_shadow:

    cmp        [edit_vertex_no],0
    je	       @f
    movd       xmm0,dword[edit_end_x]
    movd       xmm1,dword[edit_start_x]
    pxor       xmm2,xmm2
    punpcklwd  xmm0,xmm2
    punpcklwd  xmm1,xmm2
    psubd      xmm0,xmm1
;    mov	eax,30 shl 16
 ;   movd	xmm7,eax
 ;   punpcklwd	xmm7,xmm2
 ;   psubd	xmm0,xmm7
    cvtdq2ps   xmm0,xmm0

    movzx      eax,[edit_vertex_no]
    dec        eax
    shl        eax,2
    lea        eax,[eax*3]
    add        eax,[points_rotated_ptr]
    movlps     xmm1,[eax]
 ;   cvtps2dq	xmm1,xmm1
    addps      xmm1,xmm0
    movlps     [eax],xmm1


  @@:	  ; face temporaly edition routines
    mov        eax,dword[edit_face_no]
    or	       eax,eax		; only 2 indexes are checked !
    jz	       @f

    movd       xmm0,dword[edit_end_x]
    movd       xmm1,dword[edit_start_x]
    pxor       xmm2,xmm2
    punpcklwd  xmm0,xmm2
    punpcklwd  xmm1,xmm2
    psubd      xmm0,xmm1
    cvtdq2ps   xmm0,xmm0
    movzx      eax,word[edit_face_no]
    movzx      ebx,word[edit_face_no+2]
    movzx      ecx,word[edit_face_no+4]
    shl        eax,2
    shl        ebx,2
    shl        ecx,2
    lea        eax,[eax*3]
    lea        ebx,[ebx*3]
    lea        ecx,[ecx*3]
    add        eax,[points_rotated_ptr]
    add        ebx,[points_rotated_ptr]
    add        ecx,[points_rotated_ptr]
    movlps     xmm1,[eax]
    movlps     xmm2,[ebx]
    movlps     xmm3,[ecx]
    addps      xmm1,xmm0
    addps      xmm2,xmm0
    addps      xmm3,xmm0
    movlps     [eax],xmm1
    movlps     [ebx],xmm2
    movlps     [ecx],xmm3
  @@:
    cmp        dword[edit_edge_no],0
    je	       @f
    movd       xmm0,dword[edit_end_x]
    movd       xmm1,dword[edit_start_x]
    pxor       xmm2,xmm2
    punpcklwd  xmm0,xmm2
    punpcklwd  xmm1,xmm2
    psubd      xmm0,xmm1
    cvtdq2ps   xmm0,xmm0
    movzx      eax,word[edit_edge_no]
    dec        eax
    movzx      ebx,word[edit_edge_no+2]
    shl        eax,2
    shl        ebx,2
    lea        eax,[eax*3]
    lea        ebx,[ebx*3]
    add        eax,[points_rotated_ptr]
    add        ebx,[points_rotated_ptr]
    movlps     xmm1,[eax]
    movlps     xmm2,[ebx]
    addps      xmm1,xmm0
    addps      xmm2,xmm0
    movlps     [eax],xmm1
    movlps     [ebx],xmm2

  @@:
    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    xor      ecx,ecx
    mov      ebx,[points_rotated_ptr]
  @@:
    movups   xmm1,[ebx]
 ;   mulps    xmm1,xmm2
    addps    xmm1,xmm3
    movlps   [ebx],xmm1
    movhlps  xmm1,xmm1
    movss    [ebx+8],xmm1
    add      ebx,12
    add      ecx,1
    cmp      cx,[points_count_var]
    jnz      @b


    cmp [draw_flag],9
    jge .skip_th


    invoke CreateThread,NULL,NULL,draw_th0,\
	   NULL,NORMAL_PRIORITY_CLASS,\
	   [ThreadID0]
    mov    [hthread0],eax
    invoke  SetThreadPriority,hthread0,THREAD_PRIORITY_TIME_CRITICAL

    invoke CreateThread,NULL,NULL,draw_th1,\
	   NULL,NORMAL_PRIORITY_CLASS,\
	   [ThreadID1]
    mov  [hthread1],eax
    invoke  SetThreadPriority,hthread1,THREAD_PRIORITY_TIME_CRITICAL
if 0
    invoke CreateThread,NULL,NULL,draw_th2,\
	   NULL,NORMAL_PRIORITY_CLASS,\
	   [ThreadID2]
    mov  [hthread2],eax
    invoke  SetThreadPriority,hthread2,THREAD_PRIORITY_TIME_CRITICAL

;    mov  eax,draw_th3
    invoke CreateThread,NULL,NULL,draw_th3,\
	   NULL,NORMAL_PRIORITY_CLASS,\
	   [ThreadID3]
    mov  [hthread3],eax
    invoke  SetThreadPriority,hthread3,THREAD_PRIORITY_TIME_CRITICAL
end if

    invoke SetThreadAffinityMask,[hthread0],1
    invoke SetThreadAffinityMask,[hthread1],2
;    invoke SetThreadAffinityMask,[hthread2],3
;    invoke SetThreadAffinityMask,[hthread3],4
    invoke ResumeThread,[hthread0]
    invoke ResumeThread,[hthread1]
;    invoke ResumeThread,[hthread2]
;    invoke ResumeThread,[hthread3]

;    invoke WaitForMultipleObjects,4,hthread0,TRUE,0
    invoke  WaitForMultipleObjectsEx,2,hthread0,1,-1,0
    invoke CloseHandle,hthread0
    invoke CloseHandle,hthread1
;    invoke CloseHandle,hthread2
;    invoke CloseHandle,hthread3
;   jmp  @f
   .skip_th:
    call draw_thread
;   @@:



    cmp    [bezier_flag],0
    je	   .no_derives
    cmp    [derive_flag],1
    je	   .no_derives

;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
    mov   edi,[edit_buf_ptr]
    movzx ecx,[xres_var]
    movzx eax,[yres_var]
    imul  ecx,eax
    xor   eax,eax
    call  fill_aligned

    mov    edi,[screen_ptr]
    mov    ebx,[derv_rect_ptr]
    xor    ecx,ecx

  @@:
    push   ecx
    push   ebx
    mov    esi,derv_nodes_rot
    call   draw_bezier_derives1  ; only for sigle patch
    pop    ebx
    add    ebx,16*2
    pop    ecx

    add    ecx,1
    cmp    cx, [bez_patch_count]
    jnz    @b

    mov    esi,derv_nodes_rot
    mov    ebx,[derv_rect_ptr]
    movzx  ecx,[bez_patch_count]
; in:
;  esi - ptr to derives vertices list
;  ebx - ptr to derives indexes (16 pro one rectangle)
;  ecx - number of surfaces
;  globals - screen_ptr, i12, ..

    call   draw_bezier_bars


  .no_derives:

    cmp   [set_tri_area],0  ; triangukize area/rect
    jne   @f			   ;
    call   draw_triangulize_rect
  @@:
    cmp  [hrt_flag],3	   ; write frame around current segment
    jl	 .no_rectangle
    cmp  [hrt_flag],6
    jge  .no_rectangle
  @@:
    cmp  [current_seg],255
    jz	 .no_rectangle

    mov   esi,[points_rotated_ptr]
    movzx ebx,[current_seg]

    cmp   [hrt_flag],3
    jne   @f
    mov  eax,BSTEPS*BSTEPS*12
    jmp   .calc
  @@:
    cmp   [hrt_flag],4
    jne   @f
    mov   eax,[rot_pipe_points_number]
    shl   eax,2
    lea   eax,[eax*3]
    jmp   .calc
  @@:
    cmp   ebx,BPIPES ;-1
    jle   .only_pipes
    mov   eax,[rot_pipe_points_number]
    imul  eax,BPIPES*12
;    mul   edx
;    mov   ecx,ebx  ;[current_seg]
    sub   ebx,BPIPES
    imul  ebx,BSTEPS*BSTEPS*12
;  @@:
;    add   eax,BSTEPS*BSTEPS*12
;    loop  @b
    add    eax,ebx
    jmp   .skip_mul

  .only_pipes:
    mov   eax,[rot_pipe_points_number]
    shl   eax,2
    lea   eax,[eax*3]


 .calc:
    mul   ebx
 .skip_mul:
   add	 esi,eax
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   cmp	  [hrt_flag],3
   jg	  @f
   mov	  ecx,(BSTEPS*(BSTEPS))-1
   jmp	  .find
 @@:
   cmp	  [hrt_flag],4
   jg	  @f
   mov	  ecx,[rot_pipe_points_number]
   dec	  ecx
   jmp	  .find
 @@:
   cmp	  [current_seg],BPIPES
   jge	  @f
   mov	  ecx,[rot_pipe_points_number]
   dec	  ecx
   jmp	  .find
 @@:
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 .find:
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min
;   movss    xmm2,[scale]
;   shufps   xmm2,xmm2,0
;   mulps    xmm0,xmm2
;   mulps    xmm1,xmm2
 ;  cvtps2dq xmm0,xmm0
  ; cvtps2dq xmm1,xmm1
;   movdqu   xmm2,[xxadd]
;   paddd    xmm0,xmm2
;   paddd    xmm1,xmm2
   movups   xmm2,[max_clip_seg]
   movups   xmm3,[min_clip_seg]
   minps    xmm0,xmm2
   maxps    xmm1,xmm3
   cvtps2dq xmm0,xmm0
   cvtps2dq xmm1,xmm1
   movups   [cur_seg_max_rot],xmm0
   movups   [cur_seg_max_rot+12],xmm1



    ; max min coordinate should be normalized like whole object
    ; (witch is before rotating, rescaling and translating) in <-1.0 ; 1.0>


    .xsegmax equ [cur_seg_max_rot]
    .ysegmax equ [cur_seg_max_rot+4]
    .xsegmin equ [cur_seg_max_rot+12]
    .ysegmin equ [cur_seg_max_rot+16]

    movzx     eax,[xres_var]
    mov       [screen_width_var],eax ;,XRES




;    mov      eax,[cur_seg_max_rot+12]	 ; xmin
;    mov      ebx,[cur_seg_max_rot+16]	 ; ymin
;    mov      edx,ebx			 ; ymin
;    mov      ecx,[cur_seg_max_rot]	 ; xmax

    mov      ax,.xsegmin
    shl      eax,16
    mov      ax,.xsegmax
    mov      bx,.ysegmin
    shl      ebx,16
    mov      bx,.ysegmax

    push     [screen_ptr]
    pop      [lbuffer_ptr]
    call     write_frame


 @@:
   .no_rectangle:
    popad

   ; invoke	 MessageBox,[hwnd],STRdata,_tsc_title,MB_RTLREADING
;   invoke stop_ticks
ret

endp

normalize_all_light_vectors:
	mov	edi,lights
     @@:
	call	normalize_vector	   ;	   3dmath.inc
	add	edi,LIGHT_SIZE
	cmp	edi,lightsend	;ecx
	jl	@b
ret
read_hrt:
	fninit
	mov    esi,hrt_triangles
	mov    edi,[triangles_ptr]
	cld
	mov    [triangles_count_var],hrt_triangles_count
	mov    ecx,hrt_triangles_count
     @@:
	movsd
	movsw
	loop   @b
	movsd	    ; copy end mark too


	mov    esi,hrt_points
	mov    edi,[points_r_ptr]
	mov    [points_count_var],0
      @@:
	fild   word[esi]
	fstp   dword[edi]
	fild   word[esi+2]
 ;	 fchs
	fstp   dword[edi+4]
	fild   word[esi+4]
	fstp   dword[edi+8]
	inc    [points_count_var]
	add    edi,12
	add    esi,6
	cmp    dword[esi],-1
	jne    @b
	movsd	 ;copy	end mark too

ret
alloc_mem_for_tp:
     cmp     [tp_mem_alloc],1	   ; cmp triangulize cause
     jne     @f
     call    free_mem_for_tp
     jmp     .no_tp
  @@:
     movzx   eax,[points_count_var]
     imul    eax,[i12]
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_r_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [shadow_vertices_ptr],eax



     movzx   eax,[triangles_count_var]
     imul    eax,[i6]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [triangles_ptr],eax
 .no_tp:
     movzx   eax,[triangles_count_var]
     imul    eax,[i12]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [triangles_normals_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_normals_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_normals_rotated_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_rotated_ptr],eax

     movzx   eax,[points_count_var]
     shl     eax,2
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [tex_points_ptr],eax
ret
free_mem_for_tp:
   cmp	   [tp_mem_alloc],1    ; check triangulize cause
   je	   .no_tp
   mov	   ebx,[points_r_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

 ;    movzx   edx,[points_count_var]
 ;    imul    edx,[i12]
 ;    add     edx,20
     mov     ebx,[shadow_vertices_ptr]
     invoke  VirtualFree, ebx , 0,  MEM_RELEASE
     or  eax,eax
     jnz @f
  ;   int3
   @@:



   mov	   ebx,[triangles_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:
 .no_tp:
   mov	   ebx,[triangles_normals_ptr]
   movzx   eax,[triangles_count_var]
   imul    eax,[i12]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

   mov	   ebx,[points_normals_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
 ;  int3
 @@:

   mov	   ebx,[points_normals_rotated_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
 ;  int3
 @@:

   mov	   ebx,[points_rotated_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

   mov	   ebx,[tex_points_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

ret

read_tp_variables:	      ; read [triangles_count_var] and ...
			      ; ..[points_count_var]
	xor	ebx,ebx
	xor	ebp,ebp
	mov	[points_count_var],bx
	mov	[triangles_count_var],bx
	mov	esi,[File_ptr]


	cmp	[esi],word 4D4Dh
	je	@f ;Must be legal .3DS file
	xor	eax,eax
	ret
    @@:
	mov	eax,dword[esi+2]
	cmp	eax,[FileSize] ;This must tell the length
	je	@f
	xor	eax,eax
	ret
     @@:
	add	eax,esi
	mov	[EndFile],eax	 ;

	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,[EndFile]
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[points_count_var],cx

	mov	edx,ecx
	add	esi,8
     @@:

	add	ebx,6
	add	esi,12
     ;	 dec	 ecx
	loop	 @b
      @@:

      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[triangles_count_var],cx
	add	esi,8

      @@:
	add	esi,8
	dec	ecx
	jnz	@b
;	 xor	 ecx,ecx
	add	ebp,edx
	jmp	.find4k
	mov	eax,-1 ;<---mark if OK
      .exit:
ret


read_from_file:   ;; this procedure coded orginally by Madis Kalme
	fninit
    ;	 mov	 edi,[triangles_ptr]
	mov	edi,[triangles_ptr]
	xor	ebx,ebx
	xor	ebp,ebp
	mov	[points_count_var],0
	mov	[triangles_count_var],0

	mov	esi,[File_ptr]

	cmp	[esi],word 4D4Dh
	jne	.exit ;Must be legal .3DS file
;	 cmp	 dword[esi+2],EndFile-SourceFile
;	 jne	 .exit ;This must tell the length
	mov	eax,dword[esi+2]
  ;	 cmp	 eax,[fsize]
  ;	 jne	 .exit

	add	eax,esi
	mov	[EndFile],eax	 ;

	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,[EndFile]
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[points_count_var],cx

	mov	edx,ecx
	add	esi,8
     @@:
	push	edi
	mov	edi,[points_r_ptr]
	push	dword[esi+0]
	pop	dword[edi+ebx*2+0]
	push	dword[esi+4]
	pop	dword[edi+ebx*2+4]
	push	dword[esi+8]
	pop	dword[edi+ebx*2+8]
	pop	edi

	add	ebx,6
	add	esi,12
	dec	ecx
	jnz	@b
      @@:
  ;	 mov	 dword[points+ebx],-1
	push	edi
    ;	 mov	 edi,[points_ptr]
	mov	edi,[points_r_ptr]
	mov	dword[edi+ebx*2],-1	   ; end mark (not always in use)
	pop	edi
      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[triangles_count_var],cx
	add	esi,8
	;mov	 edi,[triangles_ptr]
      @@:
     ;	 movsd
     ;	 movsw
	push	dword[esi]
	pop	dword[edi]
	push	word[esi+4]
	pop	word[edi+4]
	add	edi,6
	add	esi,6
	add	word[edi-6],bp
	add	word[edi-4],bp
	add	word[edi-2],bp
	add	esi,2
	dec	ecx
	jnz	@b
	add	ebp,edx
	jmp	.find4k
	mov	eax,-1 ;<---mark if OK
      .exit:
     ;	 mov	 dword[edi],-1
ret

init_triangles_normals2:
	fninit
	mov	ebx,[triangles_normals_ptr]
	mov	ebp,[triangles_ptr]
	movzx	ecx,[triangles_count_var]
     @@:
	push	ecx
	push	ebx
	mov	ebx,vectors
	movzx	esi,word[ebp]	       ; first point index
	lea	esi,[esi*3]
    ;	 lea	 esi,[points+esi*2]	; esi - pointer to 1st 3d point
	shl	esi,2
	add	esi,[points_r_ptr]
	movzx	edi,word[ebp+2] 	 ; first point index
	lea	edi,[edi*3]
	shl	edi,2
  ;	 add	 edi,[points_ptr]
	add	edi,[points_r_ptr]
;	 movzx	 edi,word[ebp+2]	; second point index
;	 lea	 edi,[edi*3]
;	 lea	 edi,[points+edi*2]	; edi - pointer to 2nd 3d point

	call	make_vector_r
	add	ebx,12
	mov	esi,edi
	movzx	edi,word[ebp+4]        ; third point index
	lea	edi,[edi*3]
	shl	edi,2
      ;  add	 edi,[points_ptr]
	add	edi,[points_r_ptr]
;	 lea	 edi,[points+edi*2]
	call	make_vector_r
	mov	edi,ebx 		; edi - pointer to 2nd vector
	mov	esi,ebx
	sub	esi,12			; esi - pointer to 1st vector
	pop	ebx
	call	cross_product
	mov	edi,ebx
	call	normalize_vector
	add	ebp,6
	add	ebx,12
	pop	ecx
	loop	@b
    ;	 cmp	 dword[ebp],-1
      ;  jne	 @b
ret

init_point_normals:
.x equ dword [ebp-4]
.y equ dword [ebp-8]
.z equ dword [ebp-12]
.point_number equ word [ebp-26]
.hit_faces    equ word [ebp-28]

	fninit
	mov	  ebp,esp
	sub	  esp,28
	mov	  edi,[points_normals_ptr] ;[points_normals_ptr]
	mov	  .point_number,0
    .ipn_loop:
	mov	  .hit_faces,0
	mov	  .x,0
	mov	  .y,0
	mov	  .z,0
	mov	  esi,[triangles_ptr];[triangles_ptr]
	xor	  ecx,ecx	       ; ecx - triangle number
    .ipn_check_face:
	xor	  ebx,ebx	       ; ebx - 'position' in one triangle
    .ipn_check_vertex:
	movzx	  eax,word[esi+ebx]    ;  eax - point_number
	cmp	  ax,.point_number
	jne	  .ipn_next_vertex
	push	  esi
	mov	  esi,ecx
	lea	  esi,[esi*3]
       ; lea	   esi,[triangles_normals+esi*4]
	shl	  esi,2
	add	  esi,[triangles_normals_ptr];[triangles_normals_ptr]

	fld	  .x
	fadd	  dword[esi]
	fstp	  .x
	fld	  .y
	fadd	  dword[esi+4]
	fstp	  .y
	fld	  .z
	fadd	  dword[esi+8]
	fstp	  .z
	pop	  esi
	inc	  .hit_faces
	jmp	  .ipn_next_face
    .ipn_next_vertex:
	add	  ebx,2
	cmp	  ebx,6
	jne	  .ipn_check_vertex
    .ipn_next_face:
	add	  esi,6
	inc	  ecx
	cmp	  cx,[triangles_count_var]
	jne	  .ipn_check_face

	fld	  .x
	fidiv	  .hit_faces
	fstp	  dword[edi]
	fld	  .y
	fidiv	  .hit_faces
	fstp	  dword[edi+4]
	fld	  .z
	fidiv	  .hit_faces
	fstp	  dword[edi+8]
	call	  normalize_vector
	add	  edi,12  ;type vector 3d
	inc	  .point_number
	mov	  dx,.point_number
	cmp	  dx,[points_count_var]
	jne	  .ipn_loop

	mov	  esp,ebp
ret


draw_menu:

    mov    edi,menu_screen
    mov    ecx,MXRES*MYRES
    xor    eax,eax
    call   fill_aligned

    mov    [screen_width_var],MXRES
    mov    [lbuffer_ptr],menu_screen
    mov    [line_color],0x0000ff00
    mov    esi,menu_data
  .lab:
    push  esi

    mov   ax,[esi+2]
    shl   eax,16
    mov   ax,[esi+6]
    mov   bx,[esi+4]
    shl   ebx,16
    mov   bx,[esi+8]
    push  esi
    call  write_frame
    pop   esi



    mov   eax,[esi+2]	   ; write button desc
    ror   eax,16
    add   eax,0x00030000
    mov   ebx,font_table + 62
    mov   ecx,MXRES shl 16 + MYRES
    add   esi,10
    mov   edi,menu_screen
    pushad
    call  write_text
    popad

    add   eax,90 shl 16 + 0	 ; write flag of button
    cmp   dword[esi+13],-1
    je	  @f
    movzx edi,byte[esi+12]
    imul  edi,[i5]
    mov   esi,[esi+13]
    add   esi,edi
    mov   edi,menu_screen
    call  write_text
   @@:

    pop   esi
    add   esi, 33
    cmp   word[esi],-1
    jne   .lab


    movzx    eax,[whole_xres]
    mov      ecx,eax
    sub      eax,MXRES
    invoke BitBlt,[hdc],eax,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY
  ;  invoke StretchDIBits,[hdc],eax,0,MXRES,MYRES,0,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY
ret

random_point_light_position:
if 1
  rdtsc
  mov	   [rand_seed],ax
  xor	   ebx,ebx
 @@:
  push	   ebx
  mov	   ecx, -1000
  mov	   edx, 1000
  call	   random
  cvtsi2ss xmm0,eax
  pop	   ebx
  movss    [point_light_coords+ebx],xmm0
  add	   ebx,4
  cmp	   ebx,8
  jnz	   @b
end if
if 1
  xor	   ebx,ebx
  mov	   eax,255
  cvtsi2ss xmm1,[i255d]  ;eax
 @@:
  push	   ebx
  mov	   ecx, 0
  mov	   edx, 255
  call	   random
  cvtsi2ss xmm0,eax
  divss    xmm0,xmm1
  pop	   ebx
  movss    [plane_equation+ebx],xmm0
  add	   ebx,4
  cmp	   ebx,8
  jnz	   @b
end if
ret



include 'grd_cat.inc'
include 'tex_cat.inc'
include 'flat_cat.inc'
if Ext >= AVX
  include 'flat_cat_floatZavx.inc'
else
  include 'flat_cat_floatZ.inc'
end if
include '3DMATH.INC'
include 'procs_a.inc'
include 'bump_cat.inc'
include 'bump_tex.inc'
include 'two_tex.inc'
include 'grd_tex.inc'
include 'grd_line.inc'
include 'tex_line.inc'
include 'line.inc'
include  'shd3.inc'

include 'b_curve.inc'
;include 'Bline.inc'
include 'arbitrary_vector.inc'
include 'matrix.inc'
include 'rotated_bezier.inc'
;include 'b_surface.inc'
include 'asc.inc'
include 'asc_header.inc'
include 'menu.inc'
include 'edit.inc'
include 'draw_thrd.inc'
;include 'bssurface.inc'
include 'bezier_surface.inc'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class     TCHAR	 'grtest',0
    _title     TCHAR	 'Ave Cruce Salus Mea'
  if Ext = SSE2
     .exxt     TCHAR	 ' SSE2'
  else if Ext = SSE3
     .exxt     TCHAR	 ' SSE3'
  else if Ext = SSE4.1
     .exxt     TCHAR	 ' SSE4.1'
  else if Ext = AVX
     .exxt     TCHAR	 ' AVX'
  end if
  fakebitmap   dd  0,0,0,0
    .end TCHAR 0
    _error     TCHAR	 'Startup failed.',0
    _tsc_title TCHAR	 'Clocks number',0
    sh_model   TCHAR	 'Shadow + spot light                 '
	.fl    TCHAR	 'Flat Shading                        '
	.gr    TCHAR	 'Gouraud Shading                     '
	.sp    TCHAR	 'Spherical Environment Mapping       '
	.bm    TCHAR	 'Bump Mapping                        '
	.tx    TCHAR	 'Texture Maping                      '
	.grtx  TCHAR	 'Gouraud Shading and Texture Mapping '
	.dtxx  TCHAR	 'Double Texture Mapping              '
	.bmtx  TCHAR	 'Bump and Texture Mapping Pararell   '
	.grl   TCHAR	 'Gouraud Shaded Line                 '
	.flf   TCHAR	 'Flat Shading with Float zBuffer     '
	.txl   TCHAR	 'Textured Line - Env. Mapping        '
	.tx12  TCHAR	 'Textured Line                       '
	.line  TCHAR	 'Simple line without z coord. interp.'
	.shad  TCHAR	 'Nodes of object                     '
  ;  menu_text	db	  '@ABCDEFGHIJKLMNO',0
  ;  mt2	db	  'PQRSTUVWXYZ[/]^_',0
  ;  mt3	db	  'menu programu win3ds! 0123',0
;    no_display  dw 11	  ; Number of displaying models    '

    File_ptr	 dd ?
    File_tex_ptr dd ?
    SourceFile:
;    file	 'knot.3ds'
    EndFile	dd ?
    asc_file_name db 'object.asc'
    up		dd 0
    s_time	dd 0
    e_time	dd 0
    num_animations dd 3
    ccounter	   dd 0

    screen_width_var dd ?  ; SIZE_X
    triangles_count_var  dw TRIANGLES_COUNT
    points_count_var	 dw POINTS_COUNT

    convert_muler:
    dd 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000
    XYZpartices:
    db 'X','Y','Z'
    i10 dw 10




    tex_x_div2	dd  TEX_X / 2
    tex_y_div2	dd  TEX_Y / 2
    i3		dd  3
    i2		dd  2
    i5		dd  5
    i6		dd  6
    i9		dd  9
    i12 	dd  12
    i14 	dd  14
    i24 	dd  24
    i36 	dd  36
    i38 	dd  38
    i180	dw  180
    i256	dw  256
    i255d	dd  255
    f1		dd  1.0
    f3		dd  3.0
   ; f1div6	 dd  0.1666666666666667
    recipr6	dd  0.1666666666666667
    f6		dd  6.0
    env_const	dd  1.05
    dot_max	dd  1.0
    dot_min	dd  0.0
    correct_tex dw  255
    displac_div dd  5800 ;* 3 ; displacement divisior
    plane_equation:
     .A dd 0.5
     .B dd 0.5
     .C dd 1.0
     .D dd 0.0

    scale	dd 200.0
    scale_plus	dd 1.2
    scale_minus dd 0.8
    line_color	dd 0x0000ff00
    xxadd:
		dd   ?	;XRES/2
    yyadd	dd   ?	;YRES/2
    zzadd	dd 0
		dd 0
    seg_rot_flag_button_down db 0
    tex_button_pres	     db 0
    tp_mem_alloc	     db 0
    current_seg_add_flag     db 0
 ;   draw_flag	 db 1
;    blur_flag	 db 0
;    hrt_flag	 db 0
  ;  map_flag	 db 0
  ;  bump_flag	 db 0
 ;   tex_flag	 db 0
  ;  rotary_flag db 0
;    lbuffer_ptr dd buffer
    piD128:
    one_deg	dd   0.024543692
    STRdata	db   '-1        '
    main_rotary :
	       dd 0
	       dd 0
	       dd 0
    all_lights_size dw lightsend-lights
if 0
;   color of point light is color of first directional light
  point_light:
  ;  .vec	 dd -0.5, 0.4, -1.0
    p_light_max:
		dw 210,220,255,0
    p_light_o:
		dw 30,15,8,0
    p_light_min:
		dw 137,88,120,0
end if
    align 16
    point_light_coords:
	      dd -500.0
	      dd -500.0
	      dd -900.0
	      dd 0.0

    align 16
    ; bssurface constans
    mask1000  dd 0.0, 0.0, 0.0,  1.0
    mul1m33m1  dd -1.0, -3.0, 3.0, 1.0
    mul40m63  dd 3.0, -6.0, 0.0, 4.0
    mul133m3  dd -3.0,3.0, 3.0, 1.0

    tspoon_nodes:
include 'tspoon_nodes.txt'
    tpot_nodes:
include 'tpot_nodes.txt'
    tcup_nodes:
include 'tcup_nodes.txt'

    tspoon_rect:
include 'tspoon_rect.txt'
    tpot_rect:
include 'tpot_rect.txt'
    tcup_rect:
include 'tcup_rect.txt'

    bssurface_derives:
include 'utah.inc'
  dd	1.0, 1.0, 1.0
  dd	0.5, 1.0, 1.0
  dd   -0.5, 1.0, 1.0
  dd   -1.0, 1.0, 1.0
if 1
  dd	1.0, 0.5, 0.7
  dd	0.5, 0.5, 0.7
  dd   -0.5, 0.5, 0.7
  dd   -1.0, 0.5, 0.7

  dd	1.0, -0.5, 2.0
  dd	0.5, -0.5, 0.0
  dd   -0.5, -0.5, 2.0
  dd   -1.0, -0.5, 0.0

  dd	1.0, -1.0, -1.0
  dd	0.5, -1.0, -1.0
  dd   -0.5, -1.0, -1.0
  dd   -1.0, -1.0, -1.0
end if

if 0
  dd   0.0,  1.0, 0.9
  dd   0.3,  0.5, 0.8
  dd   0.0, -0.5, 0.7
  dd  -0.3, -1.0, 0.6

  dd	0.1,  0.3,  1.0
  dd	0.5,  0.3,  0.5
  dd	0.0,  0.6, -0.5
  dd   -0.8,  0.3, -1.0

  dd	 1.0, 0.9, 0.1
  dd	 0.5, 0.3, 0.3
  dd	-0.5,-0.7, 0.6
  dd	-1.0,-0.4, 0.5
end if
  lights:

    light_vect	    dd	 0.0,0.0,-1.0
    light_c_o:			     ; +12
    p_light_o:
		    dw	 51,71,11,0
    light_c_min:		     ; +20
    p_light_min:
		    dw	 15,99,17,0
    light_c_max:
    p_light_max:
		    dw	 255,255,5,0 ; +28
    shiness:
		    dw	 5	     ; +36
    LIGHT_SIZE = ($-lights)

	dd   -0.5,-0.5,-1.0
				    ;	+12
	dw   1,255,1,0
				    ;	+20
	dw   1,1,1,0
				    ;	+28
	dw   255,255,255,0
	dw   5			    ;	+36



       dd   0.5,0.5,-1.0
				   ;   +12
       dw   13,1,1,0
				   ;   +20
       dw   70,30,70,0
				   ;   +28
       dw   25,255,255,0
       dw   5			   ;   +36
   lightsend:


 align 16
    minimum0:
       dw   0,0,0,0,0,0,0,0
    maximum255:
       dw   255,255,255,255,255,255,255,255
 align 16
    mask_blend:
       dd -1,-1,-1,-1
    tex_cutter:
       dd TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE
    blur_sub:
       dd 0x01010101, 0x01010101, 0x01010101, 0x01010101
 align 16
    muler1234:
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
align 16
    muler0_7:
    muler0123:
       dd 0.0
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
       dd 5.0
       dd 6.0
       dd 7.0
mask_255f:
       dd 255.0, 255.0, 255.0, 255.0
align 16
mask_line:
	   dq 0xffffffff00ffffff
	   dq 0xffffffffffffffff
zero_hgst_dd:
	   dd 0xffffffff, 0xffffffff, 0xffffffff, 0x00000000
one_hgst_dd:
	   dd 0.0, 0.0, 0.0, 1.0
f2x4:
	   dd 2.0, 2.0, 2.0, 2.0
draw_thread_mask:
	   dw 0xffff, 0x0000, 0xffff, 0x0000
	   dw 0xffff, 0x0000, 0xffff, 0x0000
	   dd 0, 0, 0, 0
filter	   TCHAR   '3ds objects (*.3ds)',0,'*.3ds',0,\
		   'asc objects (*.asc)',0,'*.asc',0,\
		   'All files (*.*)',0,'*.*',0,0
_not3ds    TCHAR   'Not an 3d object file or read error.',0
_notraw    TCHAR   'Not an RAW 512X512 file or read error.',0
filter_tex TCHAR   'raw file 512X512 (*.raw)',0,'*.raw',0,\
		   'All files (*.*)',0,'*.*',0,0






; Sanctssimi Cordis Christi section
   hrt_points:
;cordis
dw 125,175,0, 175,175,0, 212,212,0, 250,175,0, 300,175,0, 325,200,0, 325,250,0
dw 300,300,0, 212,350,0, 125,300,0, 100,250,0, 100,200,0,175,250,-20,250,250,-20
;crux
dw 175,125,0, 200,125,0, 200,100,0, 225,100,0, 225,125,0, 250,125,0, 250,150,0
dw 225,150,0, 225,200,0, 200,200,0, 200,150,0, 175,150,0
;cordis next layer
dw 125,175,20, 175,175,20, 212,212,20, 250,175,20, 300,175,20, 325,200,20
dw 325,250,20, 300,300,20, 212,350,20, 125,300,20, 100,250,20, 100,200,20
dw 175,250,40, 250,250,40
;crux
dw 175,125,20, 200,125,20, 200,100,20, 225,100,20, 225,125,20, 250,125,20
dw 250,150,20, 225,150,20, 225,200,20, 200,200,20, 200,150,20, 175,150,20
;crown
dw 50,250,-25, 50,250,25, 100,250,75, 175,250,100,  275,250,100, 350,250,75
dw 380,250,25, 380,250,-25,350,250,-75,275,250,-100,175,250,-100, 100,250,-75
dw 50,265,-25, 100,265,75, 275,265,100,380,265,25,  350,265,-75, 175,265,-100
;thorns
dw 50,250,-50, 75,260,103, 275,240,150, 365,250,25, 350,260,-41, 150,240,-125

	hrt_points_count = ($-hrt_points)/6
dd -1
    hrt_triangles:
dw 1,0,12, 2,1,12, 9,8,12, 10,9,12, 11,10,12, 0,11,12, 12,13,2, 13,12,8, 3,2,13
dw 4,3,13, 5,4,13, 6,5,13, 7,6,13, 8,7,13
;crux
dw 22,21,23, 24,23,21, 25,24,14, 14,24,18, 18,24,20, 19,18,20, 16,15,18
dw 17,16,18
;cordis next layer
dw 26,27,38, 27,28,38, 34,35,38, 35,36,38, 36,37,38, 37,26,38, 38,39,34, 28,29,39
dw 29,30,39, 30,31,39, 31,32,39, 32,33,39, 33,34,39, 39,38,28
; crux next layer
dw 47,48,49, 49,50,47, 50,51,40, 50,40,44, 50,42,44
dw 42,43,44, 46,50,44, 44,45,46
;border cordis
dw 0,1,26, 1,27,26, 1,2,27, 28,27,2, 2,3,28, 29,28,3, 3,4,29, 30,29,4, 4,5,30
dw 31,30,5, 5,6,31, 32,31,6, 6,7,32, 33,32,7, 7,8,33, 34,33,8, 8,9,34, 35,34,9
dw 9,10,35, 36,35,10, 10,11,36, 37,36,11, 11,0,37, 37,26,0, 0,38,37
;border crux
dw 14,15,40, 41,40,15, 15,16,41, 42,41,16, 16,17,42, 43,42,17, 17,18,43
dw 44,43,18, 18,19,44, 45,44,19, 19,20,45, 46,45,20, 20,21,46, 47,46,21
dw 21,22,47, 48,47,22, 23,24,49, 50,49,24, 24,25,50, 51,50,25, 25,14,51
dw 14,40,51
;crown
dw 52,53,64, 53,54,65, 54,55,65, 55,56,66, 56,57,66, 57,58,67, 58,59,67
dw 59,60,68, 60,61,68, 61,62,69, 62,63,69, 63,64,52
;thorns
dw 52,64,70, 54,65,71, 56,66,72, 58,67,73, 68,60,74, 69,62,75
	hrt_triangles_count = (($-hrt_triangles)/6)
dd -1
;box


tetra_points_r:
dd -1.0, -1.0, 1.0
dd  1.0, -1.0, 1.0
dd  0.0,  1.0, 0.0
dd  0.0, -1.0,-1.0
tetra_points_count = 4
dd -1 ;<- end marker

tetra_triangles:
dw 0,1,2, 2,3,0, 2,1,3,  1,0,3
tetra_triangles_count = 4
dd -1 ;<- end marker
tetra_tex_points:
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dd -1
current_seg db 0      ; 255 - no segment selected
;segments_rotary:
;    dd 0  ; x ; angles (in degrees) rotary single Bezier segment
;    dd 0  ; y
;    dd 0  ; z
max_clip_seg:
    dd ?  ;XRES - 3
    dd ?  ;YRES - 3
min_clip_seg:
    dd 1.0
    dd 1.0
current_seg_add:
    dd 0       ; x ,y ,z
    dd 0
    dd 0
current_seg_add_start:
    dd 0
    dd 0
    dd 0
seg_backward_rot:
    dd 0
    dd 0
    dd 0
maxscaleseg dd 1.0
allsegcenter:
    dd 0, 0, 0, 0
rot_pipe_points_number dd  0

include  'b_rot_var_init.inc'

font_table:
file 'font8x16.bmp'
;include  'b_surface_data.inc'
if 1
;menu_button_pressed db 0
menu_button_number  dw 0
menu_data:

	       dw 0		   ; mark if button chosen
	       dw 2		   ; x1
	       dw 2		   ; y1
	       dw 85		   ; x2
	       dw 20		   ; y2
	       db 'rotary    ',0   ; label
	       db 4		   ; max flag  + 1 , if = 255, no flag
  rotary_flag  db 0		   ; flag
	       dd axl_f 	   ; offset to flags description
	       dw 1		   ; button number
	       dw VK_F12	   ; key 1
	       dw 0		   ; key 2 if '0' - none

	       dw 0
	       dw 2		   ; x1
	       dw 22		   ; y1
	       dw 85		   ; x2
	       dw 40
	       db 'mot. blur ',0
	       db 2
   blur_flag   db 1
	       dd on_of_f
	       dw 2
	       dw VK_F1
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 42		   ; y1
	       dw 85		   ; x2
	       dw 60
	       db 'zoom in   ',0
	       db 2
  zoom_in_flag db 0
	       dd -1		  ; if 0xffffffff - no flag desc
	       dw 3
	       dw VK_F3
	       dw VK_ADD

	       dw 0
	       dw 2		   ; x1
	       dw 62		   ; y1
	       dw 85		   ; x2
	       dw 80
	       db 'zoom out  ',0
	       db 2
 zoom_out_flag db 0
	       dd -1
	       dw 4
	       dw VK_F4
	       dw VK_SUBTRACT

	       dw 0
	       dw 2		   ; x1
	       dw 82		   ; y1
	       dw 85		   ; x2
	       dw 100
	       db 'tex. mapp.',0
	       db 4
    map_flag   db 0
	       dd tex_map_f
	       dw 5
	       dw VK_F5
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 102		    ; y1
	       dw 85		   ; x2
	       dw 120
	       db 'ran. light',0
	       db 2
       rd_flag db 0
	       dd -1
	       dw 6
	       dw VK_TAB
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 122		    ; y1
	       dw 85		   ; x2
	       dw 140
	       db 'dr. model ',0
	       db 15
     draw_flag db 9
	       dd -1
	       dw 7
	       dw VK_SPACE
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 142		    ; y1
	       dw 85		   ; x2
	       dw 160
	       db 'bumps     ',0
	       db 2
     bump_flag db 0
	       dd bumps_f
	       dw 8
	       dw VK_F6
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 162		    ; y1
	       dw 85		   ; x2
	       dw 180
	       db 'texture   ',0
	       db 3
     tex_flag  db 0
	       dd tex_f
	       dw 9
	       dw VK_F7
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 182		    ; y1
	       dw 85		   ; x2
	       dw 200
	       db 'save obj. ',0
	       db 2
     sav_flag  db 0
	       dd -1
	       dw 10
	       dw VK_F8
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 202		    ; y1
	       dw 85		   ; x2
	       dw 220
	       db 'run / stop',0
	       db 2
  ccounter_inc db 1
	       dd run_st_f
	       dw 11
	       dw VK_F11
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 222		    ; y1
	       dw 85		   ; x2
	       dw 240
	       db 'cur.segm. ',0
	       db 2 ;BSEGMENTS
	       db 0
	       dd -1
	       dw 12
	       dw VK_F9
	       dw 0

;		dw 0
;		dw 130		      ; x1
;		dw 2		   ; y1
;		dw 212		     ; x2
;		dw 20
;		db 'load tex. ',0
;		db 2
;		db 0
;		dd -1
;		dw 13
;		dw 0x58 	 ; x
;		dw 0

	       dw 0
	       dw 130		     ; x1
	       dw 2		  ; y1
	       dw 212		    ; x2
	       dw 20
	       db 'do displ. ',0      ; displacement
	       db 2
	       db 0
	       dd -1
	       dw 13
	       dw 0x44		; D
	       dw 0

	       dw 0
	       dw 130		     ; x1
	       dw 22		   ; y1
	       dw 212		    ; x2
	       dw 40
	       db 'do triang.',0
	       db 2
	       db 0
	       dd -1
	       dw 14
	       dw 0x54		; T
	       dw 0

	       dw 0
	       dw 130		    ; x1
	       dw 42		    ; y1
	       dw 212		    ; x2
	       dw 60		    ; y2
	       db 'cur object',0
	       db 6
      hrt_flag db 0
	       dd cur_obj_f
	       dw 15
	       dw VK_F2
	       dw 0

if 1
	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 62		   ; y1
	       dw 212		   ; x2
	       dw 80		   ; y2
	       db 'rand. shd.',0   ; label
	       db 255		   ; max flag  + 1 , if = 255, no flag
    xchg_flag  db 0		   ; flag
	       dd -1		   ; offset to flags description
	       dw 16		   ; button number
	       dw 0x55		   ; key 1
	       dw 0		   ; key 2 if '0' - none

end if

	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 82		   ; y1
	       dw 212		   ; x2
	       dw 100		   ; y2
	       db 'edit mesh.',0   ; label
	       db 4		   ; max flag  + 1 , if = 255, no flag
    edit_flag  db 0		   ; flag
	       dd edit_f	  ; offset to flags description
	       dw 17		   ; button number
	       dw 0x56		   ; key 1    'V'
	       dw 0		   ; key 2 if '0' - none


	       dw 0
	       dw 130		     ; x1
	       dw 102		     ; y1
	       dw 212		     ; x2
	       dw 120
	       db 'set t.area',0
	       db 2
 set_tri_area  db 1
	       dd on_of_f	   ; if 0xffffffff - no flag desc
	       dw 18
	       dw 0x57		   ; W
	       dw 0

	       dw 0	      ; set displacement transparent color
	       dw 130		     ; x1
	       dw 122		     ; y1
	       dw 212		     ; x2
	       dw 140
	       db 'set t. col',0
	       db 2
 disp_col_flag	db 0
	       dd displac_f	     ; if 0xffffffff - no flag desc
	       dw 19
	       dw 0x43
	       dw 0

	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 142		    ; y1
	       dw 212		   ; x2
	       dw 160		   ; y2
	       db 'dsp factor',0   ; label
	       db 4		   ; max flag  + 1 , if = 255, no flag
  disp_fac_flag  db 0		     ; flag
	       dd d_factor_f	      ; offset to flags description
	       dw 20		   ; button number
	       dw 0x46		   ; key 1    'F'
	       dw 0		   ; key 2 if '0' - none


	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 162		   ; y1
	       dw 212		   ; x2
	       dw 180		   ; y2
	       db 'bezier sr.',0   ; label
	       db 4		   ; max flag  + 1 , if = 255, no flag
  bezier_flag  db 0		   ; flag
	       dd bezier_f	   ; offset to flags description
	       dw 21		   ; button number
	       dw 0x42		   ; 'B'
	       dw 0

	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 182		   ; y1
	       dw 212		   ; x2
	       dw 200		   ; y2
	       db 'set ap tol',0   ; label
	       db 3		 ; max flag  + 1 , if = 255, no flag
tolerancy_flag db 1		   ; flag
	       dd approx_toler_f   ; offset to flags description
	       dw 22		   ; button number
	       dw 0x41		   ;   'A'
	       dw 0

	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 202		   ; y1
	       dw 212		   ; x2
	       dw 220		   ; y2
	       db 'b. derives',0   ; label
	       db 2		   ; max flag  + 1 , if = 255, no flag
derive_flag    db 1		   ; flag
	       dd on_of_f	   ; offset to flags description
	       dw 23		   ; button number
	       dw 0x45		   ;   'e'
	       dw 0

	       dw -1  ; <- end flag

end if




bezier_f:
     db 'main',0
     db 'pot ',0
     db 'cup ',0
     db 'spoo',0
approx_toler_f:
d_factor_f:
     db '1   ',0
     db '2   ',0
     db '3   ',0
     db '4   ',0
displac_f:
     db 'whit',0
     db 'blck',0
edit_f:
     db 'off ',0
     db 'vert',0
     db 'face',0
     db 'edge',0
cur_obj_f:
     db 'file',0
     db 'hrt ',0
     db 'tetr',0
     db 'r.s.',0
     db 'pipe',0
     db 'r.sp',0

tex_map_f:
     db 'p.xy',0
     db 'p.xz',0
     db 'p.yz',0
     db 'sph.',0

axl_f:
     db 'y   ',0
     db 'x   ',0
     db 'z   ',0
     db 'cust',0
on_of_f:
     db 'on  ',0
     db 'off ',0
bumps_f:
     db 'rand',0
     db 'tex ',0
tex_f:
     db 'str.',0
     db 'xor ',0
     db 'none',0
run_st_f:
    db	'stop',0
    db	'run ',0
 ;   surface_equation:
 ;   .A  dd 0.0
 ;   .B  dd 0.0
 ;   .C  dd 1.0
 ;   .D  dd 5500.0
 ;   light:
 ;   .lx dd -200
 ;   .ly dd -200
 ;   .lz dd -200
    custom_obj_angle dd 0
    custom_rot_start_x dw 0, 0
    edit_vertex_no  dw 0
    edit_face_no    dq 0
    edit_edge_no    dd 0
    edit_tri_area   db 0
    displ_transparent_col dd 0x00ffffff
align 16
    tri_area_x1     dd 7.0  ; triangulize area
    tri_area_y1     dd 7.0
    tri_area_x2     dd 2000.0
    tri_area_y2     dd 2000.0
    min_work_x	    dw 6
    min_work_y	    dw 6
    max_work_x	    dw 2000
    max_work_y	    dw 2000

    msg     MSG
    rect    RECT
    ofn     OPENFILENAME sizeof.OPENFILENAME,0,0,filter,0,0,0,fname,260 ;MAXSIZE
    ofntex  OPENFILENAME sizeof.OPENFILENAME,0,0,filter_tex,0,0,0,fnametex,260 ;MAXSIZE
    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,1,NULL,_class
    ps PAINTSTRUCT

      ; single pipe points count
    ThreadID0	dd ?
    ThreadID1	dd ?
    ThreadID2	dd ?
    ThreadID3	dd ?
;    main_rot_base1 dd ?
;    main_rot_base2 dd ?

    hthread0	    rd 1
    hthread1	    rd 1
    hthread2	    rd 1
    hthread3	    rd 1
    whole_xres	    dw ?
    whole_yres	    dw ?
    xres_var	    dw ?
    yres_var	    dw ?
    mwxres	    dw ?
    mwyres	    dw ?

    edit_start_x    dw ?
    edit_start_y    dw ?
    edit_end_x	    dw ?
    edit_end_y	    dw ?

    screen_ptr	    dd ?
    Zbuffer_ptr     dd ?
    line_buffer_var dd ?
    heap_start_ptr  dd ?
    lbuffer_ptr     dd ?
    points_r_ptr    dd ?
    triangles_ptr   dd ?
    shd_buffer_ptr  dd ?
    edit_buf_ptr    dd ?
    triangles_normals_ptr      dd ?
    points_normals_ptr	       dd ?
    points_normals_rotated_ptr dd ?
    points_rotated_ptr	       dd ?
    tex_points_ptr	       dd ?  ; bump_map  and texture coords
				    ; each point word x, word y
    shadow_vertices_ptr        dd ?






    derv_rect_ptr	       dd ?
    derv_nodes_ptr	       dd ?
    derv_nodes_rot	       rb 9148
 ;   bssurface_derives_rotated	rb 9148  ;16*32*32
    bssurface_derv_unpacked    rb 9148
 ;   derives_vertices		rb 9148
 ;   derives_indexes		rb 9148
 ;   one_bez_patch_unpacked	rb 9148
    bez_patch_count	       dw ?
    bez_nodes_count	       dw ?




    matrix		       rb 36
    p_light_vec:
	      rd 12
    shd_counter dd ?
 ;   point_light_coords:
 ;	       rd 4
    segments_add:
	      rd BSEGMENTS*3
    segments_rotary:
	      rd BSEGMENTS*3	; x ; angles (in degrees) rotary single Bezier segment
  ;  cur_seg_max:	; current edited (rotary) bezier segment min and max coordinate
  ;	       rd 3
  ;  cur_seg_min:
  ;	       rd 3
  ;	       rd 1   ; 4 byte space
    cur_seg_max_rot:
	      rd 8
    cur_seg_center:
	      rd 4
    center_scale:
	      rd 4
    max_scale dd ?
;    temp_vect:
;	       rd 4
    tex_mov_begin_x:
		     dw ? ;  \ dont change order
    tex_mov_begin_y  dw ? ;  /
    file_ext_flag    db ?   ; 0 - 3ds, 1 - asc
    fname     rb     260 ;MAXSIZE
    fnametex  rb     260
    BytesRead dd ?
    hfile     dd ?
    hfiletex  dd ?
    FileSize  dd ?
    byteswritten  dd ?
    hheap	  dd ?
    pmem	  dd ?
    pmemtex	  dd ?
    first_p_index:
		   dd ?
    second_p_index dd ?
    third_p_index  dd ?   ; don't change order
align 16
    cos_x:
		  rd 1
    sin_x	  dd ?
    neg_cos_x	  dd ?
    neg_sin_x	  dd ?
;align 16
    cos_y:
		  rd 1
    sin_y	  dd ?
    neg_cos_y	  dd ?
    neg_sin_y	  dd ?
;align 16
    cos_z:
		  rd 1
    sin_z	  dd ?
    neg_cos_z	  dd ?
    neg_sin_z	  dd ?

    rand_seed dw ?
    hwnd      dd ?
    hdc       dd ?
    bmi       BITMAPINFOHEADER
    Mbmi      BITMAPINFOHEADER
    align 16
    sse_repository:
       rd 512
  align 16
    bump_map  rb TEX_X * TEX_Y
    envmap    rd TEX_X * TEX_Y
    color_map rd TEX_X * TEX_Y
    texmap    rd TEX_X * TEX_Y
  align 16
    menu_screen rd MXRES * MYRES

    hrt_points_r:
       rb 65536



    col1:
		   dd ?
    col2	   dd ?
    col3	   dd ?
    zz1:
		   dw ?
    zz2 	   dw ?
    zz3 	   dw ? ;-> don't change order

    vectors rb 24
    angles  rb 24
    cos_tab rd 360
    sin_tab rd 360
include  'b_rot_var_uninit.inc'


section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM',\
    comdlg32,'COMDLG32'    ;   timing,'timing.dll'
    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'
    include '\include\api\comdlg32.inc'
 ;   include 'timing.inc'
;    import winmm,timeGetTime,'timeGetTime'




